
 /* Place holder for solution specific macros to be called */
%macro dabt_call_post_action_macro(m_action_cd=, m_purpose_sk=, m_project_sk=., m_abt_sk=., m_model_sk=.,
			m_scoring_model_sk=., m_scoring_template_sk=., m_actual_result_dtl_sk=., m_scoring_detail_sk=., m_pool_scheme_no=., m_post_action_flg=);

	%let m_action_cd = &m_action_cd;
	%let m_purpose_sk = &m_purpose_sk;
	%let m_project_sk = &m_project_sk;
	%let m_abt_sk = &m_abt_sk;
	%let m_model_sk = &m_model_sk;
	%let m_scoring_model_sk = &m_scoring_model_sk;
	%let m_scoring_template_sk = &m_scoring_template_sk;
	
	/*Parameters for actual/scoring/pooling added as part of hotfix 2014: S1109569 */
	%let m_actual_result_dtl_sk = &m_actual_result_dtl_sk;
	%let m_scoring_detail_sk = &m_scoring_detail_sk;
	%let m_pool_scheme_no = &m_pool_scheme_no;
	
	%let m_action_sk = .;
	proc sql noprint;
		select action_sk into :m_action_sk
		from &m_src_lib..action_master
		where kupcase(strip(action_cd)) = kupcase(strip("&m_action_cd."));
	quit;
	%let m_action_sk = &m_action_sk.;

	%let key_sk = %sysfunc(coalesce(&m_project_sk, &m_abt_sk, &m_model_sk, &m_scoring_model_sk, &m_scoring_template_sk, &m_actual_result_dtl_sk, &m_scoring_detail_sk, &m_pool_scheme_no));
	
	%let post_macro_nm = ;
	proc sql noprint;
		select post_action_macro_nm into :post_macro_nm
		from &m_src_lib..post_action_macro_config_dtl
		where action_sk = &m_action_sk. and purpose_sk = &m_purpose_sk.;
	quit;
	%let post_macro_nm = &post_macro_nm;

	%let error_flg = N;
	%let &m_post_action_flg = &error_flg;
	%if &post_macro_nm ne %then %do;
		%if &m_model_sk ne . and &m_scoring_model_sk ne . %then %do;
			/* This will be called in case of publish model */
			%&post_macro_nm(m_action_cd=&m_action_cd., m_purpose_sk=&m_purpose_sk., m_key_sk=&m_model_sk., m_scr_key_sk=&m_scoring_model_sk.);
		%end;
		/* for pooling added as part of hotfix 2014: S1109569 */
		%else %if &m_model_sk ne . and &m_pool_scheme_no ne . %then %do;
			/* This will be called in case of pooling */
			%&post_macro_nm(m_action_cd=&m_action_cd., m_purpose_sk=&m_purpose_sk., m_key_sk=&m_model_sk., m_pool_scheme_no=&m_pool_scheme_no.);
		%end;
		%else %do;
			%&post_macro_nm(m_action_cd=&m_action_cd., m_purpose_sk=&m_purpose_sk., m_key_sk=&key_sk.);
		%end;
		%let &m_post_action_flg = &error_flg;
	%end;

%mend dabt_call_post_action_macro;
