%csbinit;

%macro  csbmva_hf_wrapper();


proc sql noprint; 

select count(*) into :csb_lgd_param_hf_applied_flg
from &csb_apdm_lib_ref..PARAMETER_VALUE_DTL
where PARAMETER_NM = "CSB_UPDT_LGD_POST_BUILD_FLG";

quit; 

%let csb_lgd_param_hf_applied_flg = &csb_lgd_param_hf_applied_flg.;

%if &csb_lgd_param_hf_applied_flg = 0 %then %do;

	proc sql noprint; 
	 insert into &csb_apdm_lib_ref..PARAMETER_MASTER 
	( 
	PARAMETER_NM, PARAMETER_DESC,  
	PARAM_ADDED_BY_PRODUCT_CD ,VALUE_EDITABLE_FLG, VALUE_TO_BE_SET_BY_SOLUTN_FLG,  
	CREATED_DTTM, CREATED_BY_USER , LAST_PROCESSED_DTTM, LAST_PROCESSED_BY_USER 
	) 

	values  
	( 

	'CSB_UPDT_LGD_POST_BUILD_FLG', 'Initially LGD related variables were calculated based on base tables via DI Studio ETLs. As part of hotfix for LGD processing, in last step of abt building, LGD related variables are calculated based on FM tables via a sas code. This parameter is used to decide whether or not to activate this change after applying hot fix. If values is set to N, it will not invoke newly added sas code.', 
	'csbmid','Y','Y',  
	"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid" 
	) 

	values  
	( 
	'CSB_DEF_CPTR_PERIOD_POST_LGD_SCR', 'This parameter denotes default capture period (in months/day depending on grain of FM) post reference abt scoring date for LGD process. We score only non-default accounts. Then after scoring, we observe whether accounts default in this default capture period. LGD is calculated for these defaulted accounts.', 
	'csbmid','Y','Y',  
	"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid" 
	) 
	; 

	quit; 


	proc sql;
	 insert into &csb_apdm_lib_ref..PARAMETER_VALUE_DTL
	(
		PARAMETER_NM, VALUE_APPLICABLE_TO_PRODUCT_CD, PARAMETER_VALUE,CREATED_DTTM, CREATED_BY_USER ,	LAST_PROCESSED_DTTM, LAST_PROCESSED_BY_USER
	)
	values 
	(
	'CSB_UPDT_LGD_POST_BUILD_FLG', 'csbmid','Y', 
	"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"
	)

	values 
	(
	'CSB_DEF_CPTR_PERIOD_POST_LGD_SCR', 'csbmid','&DEFAULT_CAPTURE_PERIOD', 
	"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"
	)
	;
	quit;
%end;


proc sql noprint; 

	select count(*) into :csb_lgd_pst_actn_hf_applied_flg
	from &csb_apdm_lib_ref..POST_ACTION_MACRO_CONFIG_DTL
	where action_sk in (14, 15) and purpose_sk = 102;

quit; 

%let csb_lgd_pst_actn_hf_applied_flg = &csb_lgd_pst_actn_hf_applied_flg.;

%if &csb_lgd_pst_actn_hf_applied_flg = 0 %then %do;

	proc sql;

	  insert into &csb_apdm_lib_ref..POST_ACTION_MACRO_CONFIG_DTL

	  (action_sk,purpose_sk,POST_ACTION_MACRO_NM)

	  values  (14,102,'csbmva_post_bck_calc_wrapper')
	  values  (15,102,'csbmva_post_plg_calc_wrapper')

		;
	quit;
%end;

%else %do;
	%put "ERROR: post action macros are already configured ";
%end;

%mend;

%csbmva_hf_wrapper();
