
	/* macro to update lgd/ead and default date values */
%macro csbmva_calc_upd_lgd_var_wrapper(m_abt_type_cd=, m_object_sk=.,m_pool_scheme_no=., m_subject_of_analysis_cd=,
										m_subject_retain_key_libref=,m_subject_retain_key_tbl_nm=,
										m_subject_rk_column_nm=, m_to_be_upd_tbl_libref=,
										m_to_be_upd_tbl_nm=, m_to_be_upd_lgd_column_nm=,
										m_to_be_upd_ead_column_nm=,m_to_be_upd_def_dt_column_nm=);

	/* If update LGD post build flag is set to Y then update the LGD. 
		This parameter value is taken from apdm.parameter_value_dtl table.*/
	%if %upcase(&CSB_UPDT_LGD_POST_BUILD_FLG) eq Y %then %do; /*i18NOK:LINE */

		%let m_abt_type_cd = &m_abt_type_cd;

		/* The parameter object sk will contain the value
			actual result control sk for abt type ACT
			abt sk for abt type MDL
			model sk for abt type PLG and BCK
		*/
		%let m_object_sk = &m_object_sk;
		
		/* The parameter m_pool_scheme_no will be passed only for abt type PLG */
		%let m_pool_scheme_no = &m_pool_scheme_no;

		%let m_subject_of_analysis_cd = &m_subject_of_analysis_cd;
		%let m_subject_retain_key_libref = &m_subject_retain_key_libref;
		%let m_subject_retain_key_tbl_nm = &m_subject_retain_key_tbl_nm;
		%let m_subject_rk_column_nm = &m_subject_rk_column_nm;
		%let m_to_be_upd_tbl_libref = &m_to_be_upd_tbl_libref;
		%let m_to_be_upd_tbl_nm = &m_to_be_upd_tbl_nm;
		%let m_to_be_upd_lgd_column_nm = &m_to_be_upd_lgd_column_nm;
		%let m_to_be_upd_ead_column_nm = &m_to_be_upd_ead_column_nm;
		%let m_to_be_upd_def_dt_column_nm = &m_to_be_upd_def_dt_column_nm;


		%let m_dabt_extrnl_calc_success_flg = ;

		%let m_dabt_output_table_libref = dbscr;
		%let m_dabt_output_table_nm = %lowcase(&m_abt_type_cd.)_&m_object_sk._lgd_calc;

		%let m_dabt_subset_retain_key_libref = &m_subject_retain_key_libref;
		%let m_dabt_subset_retain_key_tbl_nm = &m_subject_retain_key_tbl_nm;

		%let m_dabt_scratch_table_libref = dbscr;
		%let m_dabt_scratch_table_cd = %lowcase(&m_abt_type_cd.)_&m_object_sk.;

		%let m_dabt_indb_processing_flg = &DABT_INDB_PROCESSING_FLG;

		%let m_dabt_subject_of_analysis_cd = &m_subject_of_analysis_cd;
		%let m_dabt_abt_type_cd = &m_abt_type_cd;
		
		%let m_dabt_build_dt_lst = ;
		%let m_dabt_outcome_period_cnt = ;
		%let m_dabt_outcome_time_frequency_cd = ;
		%let m_dabt_src_data_time_grain_cd = ;

		%if %upcase(&m_abt_type_cd) = MDL %then %do; /*i18NOK:LINE */
			proc sql noprint;
				select datepart(last_built_as_of_dttm) into :m_dabt_build_dt_lst separated by ',' /*i18NOK:LINE */
				from &dabt_lib..mdl_abt_last_run_as_of_dt_dtl  
				where abt_sk = &m_object_sk.;
			quit;

			proc sql noprint;
				select mam.target_period_cnt, tfm.time_frequency_cd, tfm1.time_frequency_cd  
						into :m_dabt_outcome_period_cnt, :m_dabt_outcome_time_frequency_cd, :m_dabt_src_data_time_grain_cd
				from &dabt_lib..modeling_abt_master mam
					inner join &dabt_lib..time_frequency_master tfm
					on (mam.target_period_time_freq_sk = tfm.time_frequency_sk)
					inner join &dabt_lib..time_frequency_master tfm1
					on (mam.source_data_time_grain_sk = tfm1.time_frequency_sk)
				where abt_sk = &m_object_sk.;
			quit;
		%end;
		%else %if %upcase(&m_abt_type_cd) = ACT %then %do; /*i18NOK:LINE */
			%let m_scr_model_sk = ;
			/* For a given actual control detail, where will exist only one date for scoring */
			proc sql noprint;
				select datepart(scd.scoring_as_of_dttm), sm.scoring_model_sk, sm.outcome_period_cnt, tfm.time_frequency_cd, tfm1.time_frequency_cd   /*i18NOK:LINE */
							into :m_dabt_build_dt_lst, :m_scr_model_sk, :m_dabt_outcome_period_cnt, :m_dabt_outcome_time_frequency_cd, :m_dabt_src_data_time_grain_cd /*i18NOK:LINE */
				from &dabt_lib..actual_result_control_detail arcd
					inner join &dabt_lib..scoring_control_detail scd
					on (arcd.scoring_control_detail_sk = scd.scoring_control_detail_sk)
					inner join &dabt_lib..scoring_model sm
					on (scd.scoring_template_sk = sm.scoring_template_sk)
					inner join &dabt_lib..time_frequency_master tfm
					on (sm.outcome_period_time_freq_sk = tfm.time_frequency_sk)
					inner join &dabt_lib..model_x_modeling_abt mma 
					on (sm.model_sk = mma.model_sk)
					inner join &dabt_lib..modeling_abt_master mam
					on (mma.abt_sk = mam.abt_sk)
					inner join &dabt_lib..time_frequency_master tfm1
					on (mam.source_data_time_grain_sk = tfm1.time_frequency_sk)
				where arcd.actual_result_control_dtl_sk = &m_object_sk.;
			quit;
			%let m_scr_model_sk = &m_scr_model_sk;
		%end;
		%else %if %upcase(&m_abt_type_cd) = BCK %then %do; /*i18NOK:LINE */
			/* In case of multiple dates for backtesting the date is stored in comma separated form in the column abt_dt*/
			proc sql noprint;
				select ABT_DT into :m_dabt_build_dt_lst
				from &csb_apdm_libref..build_backtest_abt_status  
				where model_rk = &m_object_sk.;
			quit;

			proc sql noprint;
				select mam.target_period_cnt, tfm.time_frequency_cd, tfm1.time_frequency_cd  
						into :m_dabt_outcome_period_cnt, :m_dabt_outcome_time_frequency_cd, :m_dabt_src_data_time_grain_cd
				from &dabt_lib..model_x_modeling_abt mma 
					inner join &dabt_lib..modeling_abt_master mam
					on (mma.abt_sk = mam.abt_sk)
					inner join &dabt_lib..time_frequency_master tfm
					on (mam.target_period_time_freq_sk = tfm.time_frequency_sk)
					inner join &dabt_lib..time_frequency_master tfm1
					on (mam.source_data_time_grain_sk = tfm1.time_frequency_sk)
				where model_sk = &m_object_sk.;
			quit;
		%end;
		%else %if %upcase(&m_abt_type_cd) = PLG %then %do; /*i18NOK:LINE */
			/* In case of multiple dates for pooling the date is stored in comma separated form in the column abt_dts*/
			proc sql noprint;
				select ABT_DTS into :m_dabt_build_dt_lst
				from &csb_apdm_libref..build_pool_abt_status  
				where model_rk = &m_object_sk. and pool_scheme_no = &m_pool_scheme_no;
			quit;

			proc sql noprint;
				select mam.target_period_cnt, tfm.time_frequency_cd, tfm1.time_frequency_cd  
							into :m_dabt_outcome_period_cnt, :m_dabt_outcome_time_frequency_cd, :m_dabt_src_data_time_grain_cd
				from &dabt_lib..model_x_modeling_abt mma 
					inner join &dabt_lib..modeling_abt_master mam
					on (mma.abt_sk = mam.abt_sk)
					inner join &dabt_lib..time_frequency_master tfm
					on (mam.target_period_time_freq_sk = tfm.time_frequency_sk)
					inner join &dabt_lib..time_frequency_master tfm1
					on (mam.source_data_time_grain_sk = tfm1.time_frequency_sk)
				where model_sk = &m_object_sk.;
			quit;
		%end;
		%let m_dabt_build_dt_lst = &m_dabt_build_dt_lst;
		%let m_dabt_outcome_period_cnt = &m_dabt_outcome_period_cnt;
		%let m_dabt_outcome_time_frequency_cd = &m_dabt_outcome_time_frequency_cd;
		%let m_dabt_src_data_time_grain_cd = &m_dabt_src_data_time_grain_cd;

		%if "&m_dabt_build_dt_lst" ne "" %then %do; /*i18NOK:LINE */
			%let m_dabt_build_dt_cnt = %eval(%sysfunc(countc(%quote(&m_dabt_build_dt_lst),","))+1); /*i18NOK:LINE*/

			%do m_bld_dt = 1 %to &m_dabt_build_dt_cnt;
				%let m_dabt_build_dt_tkn = %scan(%quote(&m_dabt_build_dt_lst),&m_bld_dt,%str(,)); /*i18NOK:LINE*/

				data _null_;
					%if %upcase(&m_abt_type_cd) = BCK or %upcase(&m_abt_type_cd) = PLG %then %do; /*i18NOK:LINE */
						/* Since in case of pooling and backtesting the date is stored as string in date9. format */
						dabt_bld_date = "&m_dabt_build_dt_tkn"D; /*i18NOK:LINE */
					%end;
					%else %do;
						dabt_bld_date = &m_dabt_build_dt_tkn;
					%end;
					call symput('m_dabt_build_dt',cat("'",strip(put(dabt_bld_date,date9.)),"'D")); /*i18NOK:LINE*/
					call symput('m_dabt_build_dttm',cat("'",strip(put(dhms(dabt_bld_date,23,59,59),datetime21.)),"'DT")); /*i18NOK:LINE*/
				run;

				/* Update the appropriate columns in the required table */
				%let cnt_bld_dttm_col = 0;

				%if %upcase(&m_abt_type_cd) = MDL %then %do; /*i18NOK:LINE */ 
					proc sql noprint;
						select count(*) into:cnt_bld_dttm_col 
						from dictionary.columns 
						where kupcase(libname)=kupcase("&m_to_be_upd_tbl_libref.") /*i18NOK:LINE */ 
								and kupcase(memname)=kupcase("&m_to_be_upd_tbl_nm.") and kupcase(name)='BUILD_DTTM'; /*i18NOK:LINE */ 
					quit;
					%let cnt_bld_dttm_col = &cnt_bld_dttm_col;

					/* If stack run, then subset the table for the given build dttm */
					%if &cnt_bld_dttm_col gt 0 %then %do;
						%if &DABT_INDB_PROCESSING_FLG eq Y %then %do;
		    				option &DABT_INDB_OPT_PRE_BLD_ABT_JOB;
						%end;
						
						%dabt_drop_table(m_table_nm=dbscr.mdl_&m_object_sk._subset_lgd);
						
						proc sql noprint;
							create table dbscr.mdl_&m_object_sk._subset_lgd as
							select * 
							from &m_subject_retain_key_libref..&m_subject_retain_key_tbl_nm
							where build_dttm = &m_dabt_build_dttm;
						quit;

						%if &DABT_INDB_PROCESSING_FLG eq Y %then %do;
						    options NODBIDIRECTEXEC;
						%end;

						%let m_dabt_subset_retain_key_libref = dbscr;
						%let m_dabt_subset_retain_key_tbl_nm = mdl_&m_object_sk._subset_lgd;
					%end;
				%end;

				%if %upcase(&m_abt_type_cd) = ACT %then %do; /*i18NOK:LINE */
									
					%if &DABT_INDB_PROCESSING_FLG eq Y %then %do;
						option &DABT_INDB_OPT_PRE_BLD_ABT_JOB;
					%end;

					%dabt_drop_table(m_table_nm=dbscr.act_&m_object_sk._dstnct);

					proc sql noprint;
						create table dbscr.act_&m_object_sk._dstnct as
						select &m_subject_rk_column_nm.
						from &m_dabt_subset_retain_key_libref..&m_dabt_subset_retain_key_tbl_nm.
						where &m_subject_rk_column_nm. not in (select &m_subject_rk_column_nm. from &m_to_be_upd_tbl_libref..&m_to_be_upd_tbl_nm);
					quit;

					/* List of subject_rk not present in actual abt but were were scored and present in predicted_result_ arm table */
					proc sql noprint;
						insert into &m_to_be_upd_tbl_libref..&m_to_be_upd_tbl_nm
						(&m_subject_rk_column_nm.)
						select &m_subject_rk_column_nm.
						from dbscr.act_&m_object_sk._dstnct;
					quit;

					%if &DABT_INDB_PROCESSING_FLG eq Y %then %do;
						options NODBIDIRECTEXEC;
					%end;
				%end;


				/* Call the macro to calculate LGD/EAD for each dates */
				%csbmva_ext_calc_lgd_var;

				%if &DABT_INDB_PROCESSING_FLG eq Y %then %do;
    				option &DABT_INDB_OPT_PRE_BLD_ABT_JOB;
				%end;

				proc sql noprint;
					update &m_to_be_upd_tbl_libref..&m_to_be_upd_tbl_nm t1
					set &m_to_be_upd_lgd_column_nm = (select LGD from &m_dabt_output_table_libref..&m_dabt_output_table_nm t2 where t1.&m_subject_rk_column_nm = t2.&m_subject_rk_column_nm),
						&m_to_be_upd_ead_column_nm = (select EAD from &m_dabt_output_table_libref..&m_dabt_output_table_nm t2 where t1.&m_subject_rk_column_nm = t2.&m_subject_rk_column_nm),
						
						&m_to_be_upd_def_dt_column_nm = (select DEFAULT_DT from &m_dabt_output_table_libref..&m_dabt_output_table_nm t2 where t1.&m_subject_rk_column_nm = t2.&m_subject_rk_column_nm)
						/* Update the below column for ACT.*/
						%if %upcase(&m_abt_type_cd) eq ACT %then %do; /*i18NOK:LINE */
							,
							ACT_VALUE_AT_RECOVERY = (select VALUE_AT_RECOVERY from &m_dabt_output_table_libref..&m_dabt_output_table_nm t2 where t1.&m_subject_rk_column_nm = t2.&m_subject_rk_column_nm),
							ACT_RECOVERY_COST = (select RECOVERY_COST from &m_dabt_output_table_libref..&m_dabt_output_table_nm t2 where t1.&m_subject_rk_column_nm = t2.&m_subject_rk_column_nm)
						%end;
						/* Update the below column for MDL/BCK and PLG.*/
						%else %do;
							,
							VALUE_AT_RECOVERY = (select VALUE_AT_RECOVERY from &m_dabt_output_table_libref..&m_dabt_output_table_nm t2 where t1.&m_subject_rk_column_nm = t2.&m_subject_rk_column_nm),
							RECOVERY_COST = (select RECOVERY_COST from &m_dabt_output_table_libref..&m_dabt_output_table_nm t2 where t1.&m_subject_rk_column_nm = t2.&m_subject_rk_column_nm)
						%end;
					%if &cnt_bld_dttm_col gt 0 %then %do;
						where build_dttm = &m_dabt_build_dttm
					%end;
					;
				quit;

				%if &DABT_INDB_PROCESSING_FLG eq Y %then %do;
				    options NODBIDIRECTEXEC;
				%end;
				
				/* Drop columns ACT_EAD, ACT_LGD, ACT_VALUE_AT_RECOVERY and ACT_RECOVERY_CAST as they are not used in case of BCK and PLG. */
				%if %upcase(&m_abt_type_cd) = BCK or %upcase(&m_abt_type_cd) = PLG or %upcase(&m_abt_type_cd) = MDL  %then %do; /*i18NOK:LINE */					
					%if &fm_db_eng.=TERADATA %then %do;

						%if %upcase(&m_abt_type_cd) = BCK %then %do; /*i18NOK:LINE */
							%let m_abt_schema_nm = &csb_back_abt_schema;
						%end;
						%else %if %upcase(&m_abt_type_cd) = PLG %then %do;
							%let m_abt_schema_nm = &csb_pool_abt_schema;
						%end;
						%else %if %upcase(&m_abt_type_cd) = MDL %then %do;
							%let m_abt_schema_nm = &csb_mdl_abt_schema;
						%end;

						PROC SQL;
							CONNECT TO TERADATA (server="&fm_server." authdomain=&fm_authdomain. mode=TERADATA) ; /*i18NOK:LINE */
							EXECUTE (alter table &m_abt_schema_nm..&m_to_be_upd_tbl_nm. drop ACT_EAD;
								) BY TERADATA ;
								DISCONNECT FROM TERADATA ;
						quit;

						PROC SQL;
							CONNECT TO TERADATA (server="&fm_server." authdomain=&fm_authdomain. mode=TERADATA) ; /*i18NOK:LINE */
							EXECUTE (alter table &m_abt_schema_nm..&m_to_be_upd_tbl_nm. drop ACT_VALUE_AT_RECOVERY;
								) BY TERADATA ;
								DISCONNECT FROM TERADATA ;
						quit;

						PROC SQL;
							CONNECT TO TERADATA (server="&fm_server." authdomain=&fm_authdomain. mode=TERADATA) ; /*i18NOK:LINE */
							EXECUTE (alter table &m_abt_schema_nm..&m_to_be_upd_tbl_nm. drop ACT_RECOVERY_COST;
								) BY TERADATA ;
								DISCONNECT FROM TERADATA ;
						quit;

						PROC SQL;
							CONNECT TO TERADATA (server="&fm_server." authdomain=&fm_authdomain. mode=TERADATA) ; /*i18NOK:LINE */
							EXECUTE (alter table &m_abt_schema_nm..&m_to_be_upd_tbl_nm. drop ACT_LGD;
								) BY TERADATA ;
								DISCONNECT FROM TERADATA ;
						quit;
						
						%if %upcase(&m_abt_type_cd) = MDL %then %do;
							proc sql;
								CONNECT TO TERADATA (server="&fm_server." authdomain=&fm_authdomain. mode=TERADATA) ; /*i18NOK:LINE */
								EXECUTE (alter table &m_abt_schema_nm..&m_to_be_upd_tbl_nm. drop DEFAULT_DT;
									) BY TERADATA ;
									DISCONNECT FROM TERADATA ;
							quit;	

							proc sql;
								CONNECT TO TERADATA (server="&fm_server." authdomain=&fm_authdomain. mode=TERADATA) ; /*i18NOK:LINE */
								EXECUTE (alter table &m_abt_schema_nm..&m_to_be_upd_tbl_nm. drop DEFAULT_STATUS_CD;
									) BY TERADATA ;
									DISCONNECT FROM TERADATA ;
							quit;	
						%end;	

					%end;


					%else %if &fm_db_eng.=SAS %then %do; /* Start for SAS */
						proc sql;
						  alter table &m_to_be_upd_tbl_libref..&m_to_be_upd_tbl_nm.
						  drop ACT_EAD, ACT_VALUE_AT_RECOVERY, ACT_RECOVERY_COST, ACT_LGD
						  %if %upcase(&m_abt_type_cd) = MDL %then %do;
							  , DEFAULT_DT, DEFAULT_STATUS_CD
						  %end;	 
						  ;
						quit;
					%end;
				%end;
				%else %do; /* FOR ACT */
					%if &fm_db_eng.=TERADATA %then %do;
					
						
						%let m_abt_schema_nm = &csb_act_abt_schema;

						PROC SQL;
							CONNECT TO TERADATA (server="&fm_server." authdomain=&fm_authdomain. mode=TERADATA) ; /*i18NOK:LINE */
							EXECUTE (alter table &m_abt_schema_nm..&m_to_be_upd_tbl_nm. drop LGD;
								) BY TERADATA ;
								DISCONNECT FROM TERADATA ;
						quit;

					%end;


					%else %if &fm_db_eng.=SAS %then %do; /* Start for SAS */
						proc sql;
						  alter table &m_to_be_upd_tbl_libref..&m_to_be_upd_tbl_nm.
						  drop LGD;
						quit;
					%end;
				%end;

			%end;
		%end;
	%end;
%mend csbmva_calc_upd_lgd_var_wrapper;
