%macro csbmva_edit_model_wrapper(m_action_cd  = ,
				        		 m_purpose_sk = ,
                        		 m_key_sk     = );


*===============================================================================;
* Updating the fields derived from model_master in model_master_extension table ;
*===============================================================================;
%local model_id model_short_nm model_desc last_registered_model_nm 
		 level_sk cr_mitigant_adjusted_flg created_by_user;

 	PROC SQL noprint;
		select strip(model_id) ,strip(model_short_nm),strip(model_desc) ,strip(last_registered_model_nm),
				 level_sk ,strip(cr_mitigant_adjusted_flg),strip(created_by_user)
				 into :model_id, :model_short_nm, :model_desc, :last_registered_model_nm, 
				 :level_sk, :cr_mitigant_adjusted_flg , :created_by_user				
		from  &dabt_lib..model_master 
		where model_sk=&m_key_sk;		
 	QUIT;

 	/*%let model_desc = &model_desc;*/
 	%let last_registered_model_nm = &last_registered_model_nm;
 	%let cr_mitigant_adjusted_flg = &cr_mitigant_adjusted_flg;

	%let m_purpose_cd = ;
	proc sql ;
	  select kupcase(c.purpose_cd) into :m_purpose_cd
	  from  &dabt_lib..model_master a,
	        &dabt_lib..project_master b,
	    	&dabt_lib..purpose_master c
	  where a.project_sk = b.project_sk
	  and   b.purpose_sk = c.purpose_sk
	  and   a.model_sk = &m_key_sk;
	quit;

    %let m_purpose_cd = &m_purpose_cd;

	%if &m_purpose_cd = PD %then %do;
	  proc sql noprint;
	  	update &dabt_lib..model_output_column
	 		set scoring_output_column_short_nm  = "%sysfunc(sasmsg(smd_ds.bismsg,CRS.MODEL_OUTPUT_COLUMN.SCR_OUTPUT_PD.1, noquote))"
	 		where  model_sk = &m_key_sk. and
				%kupcase(scoring_output_column_nm) = "SCORECARD_POINTS";
	  quit;
	%end;
	%else %if &m_purpose_cd = LGD %then %do;

	  %let m_target_var = ;
	  proc sql noprint;
	  	select variable_column_nm into :m_target_var
			from &dabt_lib..model_x_act_outcome_var av
				inner join &dabt_lib..variable_master vm
					on av.variable_sk = vm.variable_sk
		 	where  av.model_sk = &m_key_sk. and
				av.target_variable_flg = 'Y';
	  quit;
	  %let m_target_var = &m_target_var.;

	  proc sql noprint;
	  	update &dabt_lib..model_output_column
	 		set scoring_output_column_short_nm  = "%sysfunc(sasmsg(smd_ds.bismsg,CRS.MODEL_OUTPUT_COLUMN.SCR_OUTPUT_LGD.1, noquote))"
	 		where  model_sk = &m_key_sk. and
				%kupcase(scoring_output_column_nm) = "P_"||%kupcase("&m_target_var.");
	  quit;

	%end;
	%else %if &m_purpose_cd = CCF %then %do;

	  %let m_target_var = ;
	  proc sql noprint;
	  	select vm.variable_column_nm into :m_target_var
			from &dabt_lib..model_x_act_outcome_var av
				inner join &dabt_lib..variable_master vm
					on av.variable_sk = vm.variable_sk
		 	where  av.model_sk = &m_key_sk. and
				av.target_variable_flg = 'Y';
	  quit;
	  %let m_target_var = &m_target_var.;

	  proc sql noprint;
	  	update &dabt_lib..model_output_column
	 		set scoring_output_column_short_nm  = "%sysfunc(sasmsg(smd_ds.bismsg,CRS.MODEL_OUTPUT_COLUMN.SCR_OUTPUT_CCF.1, noquote))"
	 		where  model_sk = &m_key_sk. and
				%kupcase(scoring_output_column_nm) = "P_"||%kupcase("&m_target_var.");
	  quit;

	%end;

  PROC SQL NOPRINT;
	  update &dabt_lib..MODEL_MASTER_EXTENSION 
	  set MODEL_ID = "%sysfunc(trim(&model_id))",
	      MODEL_NM = (select kstrip(mm.model_short_nm) from &dabt_lib..model_master mm where mm.model_sk=&m_key_sk),
	      /*%if "&model_desc" ne "" %then %do;*/
	     	 MODEL_DESC=(select kstrip(mm.model_desc) from &dabt_lib..model_master mm where mm.model_sk=&m_key_sk),
	      /*%end;*/
	       %if "&last_registered_model_nm" ne "" %then %do;
         		MODEL_REGISTERED_NM="%sysfunc(trim(&last_registered_model_nm ))",
         	%end;
		 LEVEL_SK=&level_sk  ,
		  %if "&cr_mitigant_adjusted_flg" ne "" %then %do;
	      	CR_MITIGANT_ADJUSTED_FLG="%sysfunc(trim(&cr_mitigant_adjusted_flg))" ,
	      %end;
	      CREATED_BY= "%sysfunc(trim(&created_by_user))"
	  where model_key =&m_key_sk
		;
    QUIT;


%mend csbmva_edit_model_wrapper;
