%macro csbmva_fltr_feed_pool(model_key  = ,time_key = ,model_type      = );


%local m_time_key m_input_ds_nm m_feed_ds i;
%let trans_rc = 0;

data _null_;
  a = put(&time_key,cs_period_last_dttm_fmt.);
  call symput('period_end_dttm',a);
run;

proc sql;
	select pool_scheme_sk into :pool_scheme_sk from csbridge.analytical_model_x_pool_scheme
	where model_rk=&model_key
	and valid_start_dttm <= &period_end_dttm <= valid_end_dttm;
quit;
%let pool_scheme_sk=&pool_scheme_sk;

%csbmva_create_pool_feed_ds(input_ds_lib=fdebug,
								output_ds_lib=fdebug,
								output_ds_sufx=_pool_fd,
								pool_scheme_sk=&pool_scheme_sk,
								score_time_sk=&time_key,
								model_rk=&model_key,
								model_type_cd= &model_type);



%csbmva_filter_repool_status(model_key       = &model_key    ,time_key  = &time_key,
                           update_var_nm   = feed_return_cd,return_cd = &trans_rc  ,
                           status_table_nm = Fdebug.filter_pool_run_status);


%mend csbmva_fltr_feed_pool;
