/************************************************************************

  Copyright (c) 2010 by SAS Institute Inc., Cary, NC, USA.             

                                                                       

  NAME:          csbmva_insert_script_apdm_config                                  

                                                                       

  PURPOSE:       This script does the following :-

					-> Creates the ADM extensions in DABT.  

				  	-> Inserts CSB specific ADM configuration data in ADM.	

					-> Inserts data in Parameter_List_Input_Mart table for Input Mart extensions for CSB

                                                                       

  USAGE:         %csbmva_adm_config				                    

                                                                       

  PARAMETERS:    None												    

                                                                       

  HISTORY :                       										

  DATE             BY                    DETAILS                       

  12-Aug-2010      sindpc                Initial Version   

  12-Nov-2010	   sindpc				 Modifications as per deployment plan

  07-May-2012      sinmkr                Modifications as per new DABT structure

 ***********************************************************************/

/* DABT common tables insertion */



proc sql;

insert into &csb_apdm_lib_ref..SOURCE_TIME_PERIOD (

TIME_PERIOD_SK ,TIME_FREQUENCY_SK ,TIME_PERIOD_FROM ,TIME_PERIOD_TO ,TIME_PERIOD_CD ,CREATED_DTTM ,CREATED_BY_USER ,LAST_PROCESSED_DTTM ,LAST_PROCESSED_BY_USER ,TIME_PERIOD_DESC ,TIME_PERIOD_SHORT_NM 

)

VALUES( 15, 1, 1, 6, "DFTCAP", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid",

"%sysfunc(sasmsg(SASHELP.bankfdn_source_time_period,SOURCE_TIME_PERIOD.TIME_PERIOD_DS15.1, noquote))", "%sysfunc(sasmsg(SASHELP.bankfdn_source_time_period,SOURCE_TIME_PERIOD.TIME_PERIOD_SM15.1, noquote))")

;

quit;



%include "&csb_script_path./csbmva_insert_script_library_master.sas";

%include "&csb_script_path./csbmva_insert_script_source_table_master.sas";

%include "&csb_script_path./csbmva_insert_script_source_column_master.sas";



%include "&csb_script_path./csbmva_insert_script_level_master.sas";

%include "&csb_script_path./csbmva_insert_script_level_key_column_dtl.sas";



%include "&csb_script_path./csbmva_insert_script_purpose_master.sas";



proc sql;

insert into &csb_apdm_lib_ref..PURPOSE_X_LEVEL (

LEVEL_SK ,PURPOSE_SK ,CREATED_DTTM ,CREATED_BY_USER

)

VALUES(1,101,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(1,102,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(1,103,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(2,101,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(3,101,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(4,102,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(5,101,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(7,101,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(7,102,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(7,103,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(8,101,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

;

quit;





proc sql;

insert into &csb_apdm_lib_ref..SOURCE_TABLE_X_USAGE (

SOURCE_TABLE_SK ,TABLE_USAGE_SK ,CREATED_DTTM ,CREATED_BY_USER

)

VALUES(4,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(8,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(9,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(11,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(11,4,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(12,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(14,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(15,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(16,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(20,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(20,4,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(21,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(23,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(23,4,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(26,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(27,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(28,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(28,4,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(29,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(30,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(31,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(31,4,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(32,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(32,4,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(33,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(33,4,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(34,2,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(35,2,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(36,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(37,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(37,2,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(38,2,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(39,2,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(40,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(43,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(44,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(46,2,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(48,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(49,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(50,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(51,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(52,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(53,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(54,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(55,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(56,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(57,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(58,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(60,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(61,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(65,4,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(66,4,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

;

quit;

proc sql;

insert into &csb_apdm_lib_ref..SOURCE_TABLE_X_LEVEL (

SOURCE_TABLE_SK ,LEVEL_SK ,HAS_RETAINED_KEY_FLG,CREATED_DTTM ,CREATED_BY_USER

)

VALUES(1,3,"N","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(1,4,"N","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(1,5,"N","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(1,7,"N","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(1,8,"N","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(4,3,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(4,8,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(8,1,"N","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(8,2,"N","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(8,4,"N","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(8,5,"N","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(8,7,"N","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(9,5,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(11,5,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(12,3,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(14,3,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(15,3,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(16,3,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(20,3,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(23,4,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(26,1,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(26,7,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(27,4,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(28,1,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(28,7,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(29,1,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(29,7,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(30,4,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(31,4,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(32,7,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(33,8,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(34,1,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(34,7,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(35,3,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(35,8,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(36,5,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(37,2,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(37,3,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(38,4,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(39,2,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(39,5,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(40,2,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(46,5,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(48,8,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(49,8,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(50,8,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(51,8,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(47,4,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(47,5,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(47,7,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(52,7,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(53,8,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(54,1,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(55,3,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(56,4,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(57,2,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(58,5,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(60,1,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(60,7,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(61,4,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(43,5,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(44,5,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(37,5,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(37,8,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(2,5,"N","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(2,7,"N","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(19,5,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(19,7,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(65,7,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(66,4,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(67,3,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(67,8,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(63,5,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(62,7,"Y","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(2,4,"N","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(3,4,"N","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(3,5,"N","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(3,7,"N","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(6,5,"N","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(7,4,"N","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(7,5,"N","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(7,7,"N","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

;

quit;



proc sql;

insert into &csb_apdm_lib_ref..SOURCE_TABLE_X_TIME_FREQUENCY (

SOURCE_TABLE_SK ,TIME_FREQUENCY_SK ,CREATED_DTTM ,CREATED_BY_USER

)

VALUES(4,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(8,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(9,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(29,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(30,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(37,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(40,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(52,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(53,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(54,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(55,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(56,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(57,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(58,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(60,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(61,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(65,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(66,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(11,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(12,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(14,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(15,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(16,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(20,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(21,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(23,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(26,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(27,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(28,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(31,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(32,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(33,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(34,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(35,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(36,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(38,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(39,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(43,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(44,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(46,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(48,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(49,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(50,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(51,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(67,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

;

quit;



proc sql;

insert into &csb_apdm_lib_ref..SOURCE_TABLE_X_PURPOSE (

SOURCE_TABLE_SK ,PURPOSE_SK ,CREATED_DTTM ,CREATED_BY_USER

)

values(1,103,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(1,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(1,102,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(2,103,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(2,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(2,102,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(3,103,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(3,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(3,102,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(4,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(6,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(7,103,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(7,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(7,102,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(8,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(8,102,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(8,103,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(9,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(11,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(12,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(13,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(14,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(15,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(16,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(17,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(17,102,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(17,103,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(18,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(18,102,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(18,103,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(19,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(19,102,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(19,103,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(20,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(23,102,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(26,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(26,102,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(26,103,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(27,102,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(32,102,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(32,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(32,103,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(33,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(34,103,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(34,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(34,102,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(35,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(36,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(37,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(38,102,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(39,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(40,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(41,103,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(41,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(41,102,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(43,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(44,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(45,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(46,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(47,103,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(47,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(47,102,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(48,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(49,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(50,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(51,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(52,102,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(52,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(52,103,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(53,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(54,103,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(54,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(54,102,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(55,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(56,102,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(57,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

values(58,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(56,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(56,103,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(27,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(27,103,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(23,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(23,103,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(38,101,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(38,103,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(36,102,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(36,103,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(9,102,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(9,103,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(46,102,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(46,103,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(11,102,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(11,103,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(43,102,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(43,103,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(44,102,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(44,103,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(58,102,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(58,103,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(37,102,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(37,103,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(39,102,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(39,103,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(40,102,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(40,103,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(6,102,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(6,103,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(45,102,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(45,103,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(13,102,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(13,103,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(57,102,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(57,103,"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

;

quit;



proc sql;

insert into &csb_apdm_lib_ref..SOURCE_COLUMN_X_USAGE (

SOURCE_COLUMN_SK ,COLUMN_USAGE_SK ,CREATED_DTTM ,CREATED_BY_USER

)

VALUES(2083,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(369,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(626,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(627,4,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(729,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(730,4,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(936,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(937,4,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(1035,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(1036,4,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(1134,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(1135,4,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(1282,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(1283,4,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(1330,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(1331,4,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(1426,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(1427,4,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(1554,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(1555,4,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(1559,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(1560,4,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(1565,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(1566,4,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(1570,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(1577,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(1587,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(1588,4,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(1984,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(1985,2,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(1981,2,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(1975,2,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(1970,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(1969,4,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(1944,2,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(1908,2,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(1710,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(1711,4,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(1676,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(1677,4,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(2246,2,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(2247,2,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(2214,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(2351,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(2352,4,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(2459,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(2460,4,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(2567,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(2568,4,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(2675,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(2676,4,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(2707,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(2763,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(2722,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(2776,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(2736,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(2789,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(2750,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(2806,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(2862,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(2871,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(2100,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(2101,4,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(2152,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(2153,4,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(3132,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(3133,4,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(3212,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(3213,4,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(3318,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(3319,4,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(3285,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(3286,4,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(3313,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(3314,4,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")


VALUES(3360,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(3361,4,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(3362,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(3363,4,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

;

quit;



%include "&csb_script_path./csbmva_insert_script_source_dim_attrib_value_master.sas";





%include "&csb_script_path./csbmva_insert_script_subset_from_path_master.sas";





proc sql;

insert into &csb_apdm_lib_ref..SUBSET_FROM_PATH_X_LEVEL (

SUBSET_FROM_PATH_SK ,LEVEL_SK ,SELECT_SOURCE_COLUMN_SK ,CORRSP_LEVEL_KEY_COLUMN_DTL_SK, CREATED_DTTM ,CREATED_BY_USER

)

VALUES(4,3,1281,5,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(5,4,1399,.,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(6,5,528,9,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(7,5,3094,.,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(8,5,3247,.,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(7,7,3136,.,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(8,4,3289,.,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(9,1,1561,.,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(10,4,1583,.,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(11,7,1596,11,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(12,8,1709,13,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(9,7,1561,.,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

;

quit;



proc sql;

insert into &csb_apdm_lib_ref..SUBSET_TABLE_JOIN_CONDITION (

SUBSET_TABLE_JOIN_CONDITION_SK ,SUBSET_FROM_PATH_SK ,JOIN_CONDITION_SEQUENCE_NUMBER ,JOIN_TYPE ,LEFT_TABLE_SK ,LEFT_COLUMN_SK ,RIGHT_TABLE_SK ,RIGHT_COLUMN_SK ,CREATED_DTTM ,CREATED_BY_USER ,LAST_PROCESSED_DTTM ,LAST_PROCESSED_BY_USER 

)

VALUES(4,4,1,'NONE',20,.,.,.,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(5,5,1,'NONE',23,.,.,.,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(6,6,1,'NONE',11,.,.,.,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(7,7,1,'NONE',65,.,.,.,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(8,8,1,'NONE',66,.,.,.,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(9,9,1,'NONE',28,.,.,.,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(10,10,1,'NONE',31,.,.,.,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(11,11,1,'NONE',32,.,.,.,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(12,12,1,'NONE',33,.,.,.,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

;

quit;





%include "&csb_script_path./csbmva_insert_script_event_master.sas";



proc sql;

insert into &csb_apdm_lib_ref..EVENT_MAPPING_DTL (

LEVEL_SK ,PURPOSE_SK ,EVENT_SK ,CREATED_DTTM ,CREATED_BY_USER ,LAST_PROCESSED_DTTM ,LAST_PROCESSED_BY_USER 

)

VALUES(3,101,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(1,102,2,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(4,102,2,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(1,103,2,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(8,101,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(7,102,2,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(7,103,2,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

;

quit;

proc sql;

insert into &csb_apdm_lib_ref..PURPOSE_TIME_GRAIN_CONFIG_DTL (

PURPOSE_SK ,SOURCE_DATA_TIME_GRAIN_SK ,OUTCOME_PERIOD_MIN_VALUE ,OUTCOME_PERIOD_MAX_VALUE ,OUTCOME_PERIOD_DEFAULT_VALUE ,CREATED_DTTM ,CREATED_BY_USER ,LAST_PROCESSED_DTTM ,LAST_PROCESSED_BY_USER 

)

VALUES(101,1,1,99,.,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(101,2,1,9999,.,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,1,1,99,13,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,2,1,9999,720,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(103,1,0,99,0,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(103,2,0,9999,0,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

;

quit;

proc sql;

insert into &csb_apdm_lib_ref..PURPOSE_LEVEL_CONFIG_DTL (

PURPOSE_SK ,LEVEL_SK ,MODEL_CAPTURE_FORM_CD ,OUTCOME_PERIOD_DISPLAY_FLG ,OUTCOME_PERIOD_READ_ONLY_FLG ,APPLY_OC_PST_IMPL_SBST_MDL_FLG ,APPLY_OC_PST_IMPL_SBST_SCR_FLG ,

ARA_SCORING_TABLE_NM,ARA_ACTUAL_TABLE_NM, CREATED_DTTM ,CREATED_BY_USER ,LAST_PROCESSED_DTTM ,LAST_PROCESSED_BY_USER,

APPLY_SGFN_VAR_CHK_FLG,MAKE_ALL_MDL_VAR_AS_SGFN_FLG,ENABLE_BLDABT_WTOUT_VARS_FLG,ADD_AGGRN_VAR_IN_ARA_ETN_FLG,ENABLE_BCK_PROCESSING_FLG,ENABLE_POOLING_PROCESSING_FLG, APPLY_TGTVAR_CHCK_CPTR_MDL_FLG,
OUTCOME_VAR_APPLICABLE_FLG, OC_PST_IMPL_SBST_APPL_FLG

)

VALUES(101,1,'PD_A','Y','N','Y','Y','PREDICTED_SCORING_RESULT_ACCNT','ACTUAL_RESULT_ACCNT',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",'Y','N','N','N','Y','Y','Y','Y','Y')

VALUES(101,2,'PD_I','Y','N','Y','Y','PREDICTED_SCORING_RESULT_CUST','ACTUAL_RESULT_CUST',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",'Y','N','N','N','Y','Y','Y','Y','Y')

VALUES(101,3,'PD_P','Y','N','N','N','PREDICTED_SCORING_RESULT_APPL','ACTUAL_RESULT_APPL',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",'Y','N','N','N','Y','Y','Y','Y','Y')

VALUES(101,5,'PD_I','Y','N','Y','Y','PREDICTED_SCORING_RESULT_CORP','ACTUAL_RESULT_CORP',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",'Y','N','N','N','Y','Y','Y','Y','Y')

VALUES(101,7,'PD_A','Y','N','Y','Y','PREDICTED_SCORING_RESULT_ACCNT','ACTUAL_RESULT_ACCNT',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",'Y','N','N','N','Y','Y','Y','Y','Y')

VALUES(101,8,'PD_P','Y','N','N','N','PREDICTED_SCORING_RESULT_APPL','ACTUAL_RESULT_APPL',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",'Y','N','N','N','Y','Y','Y','Y','Y')

VALUES(102,1,'LGD_A','N','Y','N','N','PREDICTED_SCORING_RESULT_ACCNT','ACTUAL_RESULT_ACCNT',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",'Y','N','N','N','Y','Y','Y','Y','N')

VALUES(102,4,'LGD_F','N','Y','N','N','PREDICTED_SCORING_RESULT_CRD','ACTUAL_RESULT_CRD',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",'Y','N','N','N','Y','Y','Y','Y','N')

VALUES(102,7,'LGD_A','N','Y','N','N','PREDICTED_SCORING_RESULT_ACCNT','ACTUAL_RESULT_ACCNT',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",'Y','N','N','N','Y','Y','Y','Y','N')

VALUES(103,1,'CCF_A','N','Y','N','N','PREDICTED_SCORING_RESULT_ACCNT','ACTUAL_RESULT_ACCNT',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",'Y','N','N','N','Y','Y','Y','Y','N')

VALUES(103,7,'CCF_A','N','Y','N','N','PREDICTED_SCORING_RESULT_ACCNT','ACTUAL_RESULT_ACCNT',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",'Y','N','N','N','Y','Y','Y','Y','N')

;

quit;





proc sql;

insert into &csb_apdm_lib_ref..LEVEL_ASSOC (

LEVEL_SK ,ASSOC_LEVEL_SK ,MAPPING_SOURCE_TABLE_SK ,CREATED_DTTM ,CREATED_BY_USER ,LAST_PROCESSED_DTTM ,LAST_PROCESSED_BY_USER 

)

VALUES(7,5,62,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(7,4,62,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(3,2,67,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(8,5,67,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(4,5,23,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

;

quit;





%include "&csb_script_path./csbmva_insert_script_modeling_abt_master.sas";





proc sql;

insert into &csb_apdm_lib_ref..VARIABLE_MASTER (

VARIABLE_SK ,VARIABLE_TYPE_SK ,COLUMN_DATA_TYPE_SK ,VARIABLE_COLUMN_NM ,SOURCE_TABLE_SK ,VARIABLE_DEFINITION_STRING ,CREATED_DTTM ,CREATED_BY_USER ,LAST_PROCESSED_DTTM ,LAST_PROCESSED_BY_USER ,LEVEL_SK 

)

VALUES(1,3,2,'OUTCOME_CD',20,'spm_3_20_1317_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",3)

VALUES(12,3,2,'OUTCOME_CD',20,'spm_3_20_1317_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",3)

VALUES(13,1,1,'P_MAX_SNP_DAY_PAYP_1_12M',1,'beh_3_3_1_20_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",3)

VALUES(20,1,1,'P_MAX_SNP_DAY_PAYP_L1M',1,'beh_3_3_1_20_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",3)

VALUES(22,4,1,'PDA_OUT_VAR_EVER_BAD_30',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(23,4,1,'PDA_OUT_VAR_EVER_BAD_60',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(26,4,1,'PDA_OUT_VAR_EVER_BAD_90',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(27,4,1,'PDA_OUT_VAR_EVER_BAD_120',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(28,4,1,'PDA_OUT_VAR_EVER_BAD_180',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(29,4,1,'PDA_OUT_VAR_CURR_BAD_30',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(30,4,1,'PDA_OUT_VAR_CURR_BAD_60',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(31,4,1,'PDA_OUT_VAR_CURR_BAD_90',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(32,4,1,'PDA_OUT_VAR_CURR_BAD_120',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(33,4,1,'PDA_OUT_VAR_CURR_BAD_180',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(34,1,1,'P_MAX_SNP_DEF_CNT_1_12M',1,'beh_3_3_1_27_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",3)

VALUES(35,1,1,'P_MAX_SNP_DEF_CNT_L1M',1,'beh_3_3_1_27_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",3)

VALUES(36,4,1,'PDA_OUT_EVER_CUSTOM_BAD',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(37,4,1,'PDA_OUT_CURR_CUSTOM_BAD',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(38,1,1,'P_SUM_SNP_DPD30_1_12M',1,'beh_3_1_1_1431_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",3)

VALUES(39,1,1,'P_SUM_SNP_DPD60_1_12M',1,'beh_3_1_1_1432_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",3)

VALUES(40,1,1,'P_SUM_SNP_DPD90_1_12M',1,'beh_3_1_1_1433_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",3)

VALUES(41,1,1,'P_SUM_SNP_DPD120_1_12M',1,'beh_3_1_1_1593_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",3)

VALUES(42,1,1,'P_SUM_SNP_DPD180_1_12M',1,'beh_3_1_1_2220_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",3)

VALUES(43,1,1,'P_SUM_SNP_CHRG_OFC_1_12M',1,'beh_3_1_1_1434_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",3)

VALUES(44,4,1,'PDA_OUT_VAR_COMPLEX_BAD_1',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(45,4,1,'PDA_OUT_VAR_COMPLEX_BAD_2',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(46,3,2,'OUTCOME_CD',33,'spm_8_33_1745_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",8)

VALUES(47,1,1,'A_MAX_SNP_DAY_PAYP_1_12M',1,'beh_1_3_1_20_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",1)

VALUES(48,4,1,'PDO_I_A_OUT_EVER_BAD_30',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(49,4,1,'PDO_I_A_OUT_EVER_BAD_60',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(50,4,1,'PDO_I_A_OUT_EVER_BAD_90',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(51,4,1,'PDO_I_A_OUT_EVER_BAD_120',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(52,4,1,'PDO_I_A_OUT_EVER_BAD_180',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(53,1,1,'A_MAX_SNP_DAY_PAYP_L1M',1,'beh_1_3_1_20_1',1610970315.3,"&sysuserid",1610970315.3,"&sysuserid",1)

VALUES(54,4,1,'PDO_I_A_OUT_CURR_BAD_30',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(55,4,1,'PDO_I_A_OUT_CURR_BAD_60',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(56,4,1,'PDO_I_A_OUT_CURR_BAD_90',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(57,4,1,'PDO_I_A_OUT_CURR_BAD_120',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(58,4,1,'PDO_I_A_OUT_CURR_BAD_180',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(59,1,1,'A_MAX_SNP_DEF_CNT_1_12M',1,'beh_1_3_1_27_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",1)

VALUES(60,1,1,'A_MAX_SNP_DEF_CNT_L1M',1,'beh_1_3_1_27_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",1)

VALUES(61,4,1,'PDO_I_A_EVER_CUSTOM_BAD',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(63,4,1,'PDO_I_A_CURR_CUSTOM_BAD',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(64,1,1,'A_MAX_SNP_CHRG_OFC_1_12M',1,'beh_1_3_1_1434_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",1)

VALUES(65,4,1,'PDO_I_A_EVER_CHARGED_OFF',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(66,1,1,'A_SUM_SNP_DPD30_1_12M',1,'beh_1_1_1_1431_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",1)

VALUES(67,1,1,'A_SUM_SNP_DPD60_1_12M',1,'beh_1_1_1_1432_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",1)

VALUES(68,1,1,'A_SUM_SNP_DPD90_1_12M',1,'beh_1_1_1_1433_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",1)

VALUES(69,1,1,'A_SUM_SNP_DPD120_1_12M',1,'beh_1_1_1_1593_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",1)

;

quit;

proc sql;

insert into &csb_apdm_lib_ref..VARIABLE_MASTER (

VARIABLE_SK ,VARIABLE_TYPE_SK ,COLUMN_DATA_TYPE_SK ,VARIABLE_COLUMN_NM ,SOURCE_TABLE_SK ,VARIABLE_DEFINITION_STRING ,CREATED_DTTM ,CREATED_BY_USER ,LAST_PROCESSED_DTTM ,LAST_PROCESSED_BY_USER ,LEVEL_SK 

)

VALUES(70,1,1,'A_SUM_SNP_DPD180_1_12M',1,'beh_1_1_1_2220_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",1)

VALUES(71,1,1,'A_SUM_SNP_CHRG_OFC_1_12M',1,'beh_1_1_1_1434_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",1)

VALUES(72,4,1,'PDO_I_A_COMPLEX_BAD_1',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(73,4,1,'PDO_I_A_COMPLEX_BAD_2',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(74,1,1,'I_MAX_SNP_DAY_PAYP_1_12M',1,'beh_2_3_1_20_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",2)

VALUES(75,1,1,'I_MAX_SNP_DAY_PAYP_L1M',1,'beh_2_3_1_20_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",2)

VALUES(76,4,1,'PDO_I_CUS_EVER_BAD_30',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(77,4,1,'PDO_I_CUS_EVER_BAD_60',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(78,4,1,'PDO_I_CUS_EVER_BAD_90',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(79,4,1,'PDO_I_CUS_EVER_BAD_120',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(80,4,1,'PDO_I_CUS_EVER_BAD_180',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(81,4,1,'PDO_I_CUS_CURRENT_BAD_30',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(82,4,1,'PDO_I_CUS_CURRENT_BAD_60',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(83,4,1,'PDO_I_CUS_CURRENT_BAD_90',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(84,4,1,'PDO_I_CUS_CURRENT_BAD_120',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(85,4,1,'PDO_I_CUS_CURRENT_BAD_180',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(86,1,1,'I_MAX_SNP_DEF_CNT_1_12M',1,'beh_2_3_1_27_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",2)

VALUES(87,1,1,'I_MAX_SNP_DEF_CNT_L1M',1,'beh_2_3_1_27_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",2)

VALUES(88,1,1,'I_MAX_SNP_CHRG_OFC_1_12M',1,'beh_2_3_1_1434_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",2)

VALUES(89,4,1,'PDO_I_CUS_EVER_CUSTOM_BAD',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(91,4,1,'PDO_I_CUS_EVER_CHARGED_OFF',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(92,1,1,'I_SUM_SNP_DPD30_1_12M',1,'beh_2_1_1_1431_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",2)

VALUES(93,1,1,'I_SUM_SNP_DPD60_1_12M',1,'beh_2_1_1_1432_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",2)

VALUES(94,1,1,'I_SUM_SNP_DPD90_1_12M',1,'beh_2_1_1_1433_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",2)

VALUES(95,1,1,'I_SUM_SNP_DPD180_1_12M',1,'beh_2_1_1_2220_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",2)

VALUES(96,1,1,'I_SUM_SNP_DPD120_1_12M',1,'beh_2_1_1_1593_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",2)

VALUES(97,4,1,'PDO_CUS_CURRENT_CUSTOM_BAD',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(98,4,1,'PDO_I_CUS_COMPLEX_BAD_1',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(99,4,1,'PDO_I_CUS_COMPLEX_BAD_2',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(100,1,1,'C_MAX_SNP_DAY_PAYP_1_12M',1,'beh_5_3_1_20_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",5)

VALUES(101,1,1,'C_MAX_SNP_DAY_PAYP_L1M',1,'beh_5_3_1_20_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",5)

VALUES(102,1,1,'C_MAX_SNP_DEF_CNT_1_12M',1,'beh_5_3_1_27_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",5)

VALUES(103,1,1,'C_MAX_SNP_DEF_CNT_L1M',1,'beh_5_3_1_27_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",5)

VALUES(104,1,1,'C_MAX_SNP_CHRG_OFC_1_12M',1,'beh_5_3_1_1434_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",5)

VALUES(105,1,1,'C_SUM_SNP_DPD30_1_12M',1,'beh_5_1_1_1431_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",5)

VALUES(106,1,1,'C_SUM_SNP_DPD60_1_12M',1,'beh_5_1_1_1432_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",5)

VALUES(107,1,1,'C_SUM_SNP_DPD90_1_12M',1,'beh_5_1_1_1433_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",5)

VALUES(108,1,1,'C_SUM_SNP_DPD120_1_12M',1,'beh_5_1_1_1593_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",5)

VALUES(109,1,1,'C_SUM_SNP_DPD180_1_12M',1,'beh_5_1_1_2220_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",5)

VALUES(110,4,1,'PDO_C_CUS_EVER_BAD_30',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(111,4,1,'PDO_C_CUS_EVER_BAD_60',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(112,4,1,'PDO_C_CUS_EVER_BAD_90',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(113,4,1,'PDO_C_CUS_EVER_BAD_120',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(114,4,1,'PDO_C_CUS_EVER_BAD_180',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(115,4,1,'PDO_C_CUS_CURRENT_BAD_30',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(116,4,1,'PDO_C_CUS_CURRENT_BAD_60',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(117,4,1,'PDO_C_CUS_CURRENT_BAD_90',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(118,4,1,'PDO_C_CUS_CURRENT_BAD_120',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(119,4,1,'PDO_C_CUS_CURRENT_BAD_180',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(120,4,1,'PDO_CRP_CS_EVER_CUSTOM_BAD',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

;

quit;

proc sql;

insert into &csb_apdm_lib_ref..VARIABLE_MASTER (

VARIABLE_SK ,VARIABLE_TYPE_SK ,COLUMN_DATA_TYPE_SK ,VARIABLE_COLUMN_NM ,SOURCE_TABLE_SK ,VARIABLE_DEFINITION_STRING ,CREATED_DTTM ,CREATED_BY_USER ,LAST_PROCESSED_DTTM ,LAST_PROCESSED_BY_USER ,LEVEL_SK 

)

VALUES(121,4,1,'PDO_CRP_CUS_CUR_CUSTOM_BAD',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(122,4,1,'PDO_CRP_EVER_CHARGED_OFF',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(123,4,1,'PDO_CRP_CUS_COMPLEX_BAD_1',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(124,4,1,'PDO_CRP_CUS_COMPLEX_BAD_2',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(126,1,1,'EAD',29,'beh_1_1_29_1572_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",1)

VALUES(127,1,1,'VALUE_AT_RECOVERY',29,'beh_1_1_29_1573_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",1)

VALUES(128,1,1,'RECOVERY_COST',29,'beh_1_1_29_1574_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",1)

VALUES(129,4,1,'LGD',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(131,1,1,'EAD',29,'beh_7_1_29_1572_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(132,1,1,'VALUE_AT_RECOVERY',29,'beh_7_1_29_1573_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(133,1,1,'RECOVERY_COST',29,'beh_7_1_29_1574_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(134,4,1,'LGD',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(135,1,1,'EAD',30,'beh_4_1_30_1579_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",4)

VALUES(136,1,1,'VALUE_AT_RECOVERY',30,'beh_4_1_30_1580_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",4)

VALUES(137,1,1,'RECOVERY_COST',30,'beh_4_1_30_1581_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",4)

VALUES(140,1,1,'SUM_TOT_BAL_L1M',1,'beh_1_1_1_80_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",1)

VALUES(141,1,1,'SUM_CUR_LIMIT_AMT_L1M',1,'beh_1_1_1_77_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",1)

VALUES(142,1,1,'SUM_CUR_LIMIT_AMT_12MB',1,'beh_1_1_1_77_13',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",1)

VALUES(143,1,1,'AVG_TOT_BAL_13_24M',1,'beh_1_2_1_80_3',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",1)

VALUES(144,4,1,'CCF',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(145,1,1,'SUM_TOT_BAL_L1M',1,'beh_7_1_1_80_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(146,1,1,'SUM_CUR_LIMIT_AMT_L1M',1,'beh_7_1_1_77_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(147,1,1,'AVG_TOT_BAL_13_24M',1,'beh_7_2_1_80_3',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(148,1,1,'SUM_CUR_LIMIT_AMT_12MB',1,'beh_7_1_1_77_13',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(149,4,1,'CCF',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(150,3,2,'CUSTOMER_ID',13,'spm_2_13_736_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",2)

VALUES(151,3,2,'CUSTOMER_ID',11,'spm_5_11_529_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",5)

VALUES(152,3,2,'CUSTOMER_ID',13,'spm_2_13_736_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",2)

VALUES(153,3,2,'CUSTOMER_ID',11,'spm_5_11_529_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",5)

VALUES(154,3,2,'CREDIT_FACILITY_ID',23,'spm_4_23_1400_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",4)

VALUES(155,3,2,'CUSTOMER_ID',13,'spm_2_13_736_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",2)

VALUES(156,3,2,'CUSTOMER_ID',11,'spm_5_11_529_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",5)

VALUES(157,3,2,'CREDIT_FACILITY_ID',23,'spm_4_23_1400_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",4)

VALUES(158,3,2,'CUSTOMER_ID',13,'spm_2_13_736_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",2)

VALUES(159,3,2,'CUSTOMER_ID',11,'spm_5_11_529_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",5)

VALUES(160,3,2,'CREDIT_FACILITY_ID',23,'spm_4_23_1400_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",4)

VALUES(164,3,2,'OUTCOME_CD',33,'spm_8_33_1745_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",8)

VALUES(165,1,1,'Q_MAX_SNP_DAY_PAYP_1_12M',1,'beh_8_3_1_20_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",8)

VALUES(166,1,1,'Q_MAX_SNP_DAY_PAYP_L1M',1,'beh_8_3_1_20_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",8)

VALUES(167,1,1,'Q_MAX_SNP_DEF_CNT_1_12M',1,'beh_8_3_1_27_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",8)

VALUES(168,1,1,'Q_MAX_SNP_DEF_CNT_L1M',1,'beh_8_3_1_27_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",8)

VALUES(169,1,1,'Q_SUM_SNP_DPD30_1_12M',1,'beh_8_1_1_1431_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",8)

VALUES(170,1,1,'Q_SUM_SNP_DPD180_1_12M',1,'beh_8_1_1_2220_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",8)

VALUES(171,1,1,'Q_SUM_SNP_DPD120_1_12M',1,'beh_8_1_1_1593_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",8)

VALUES(172,1,1,'Q_SUM_SNP_DPD60_1_12M',1,'beh_8_1_1_1432_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",8)

VALUES(173,1,1,'Q_SUM_SNP_DPD90_1_12M',1,'beh_8_1_1_1433_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",8)

;

quit;

proc sql;

insert into &csb_apdm_lib_ref..VARIABLE_MASTER (

VARIABLE_SK ,VARIABLE_TYPE_SK ,COLUMN_DATA_TYPE_SK ,VARIABLE_COLUMN_NM ,SOURCE_TABLE_SK ,VARIABLE_DEFINITION_STRING ,CREATED_DTTM ,CREATED_BY_USER ,LAST_PROCESSED_DTTM ,LAST_PROCESSED_BY_USER ,LEVEL_SK 

)

VALUES(174,1,1,'Q_SUM_SNP_CHRG_OFC_1_12M',1,'beh_8_1_1_1434_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",8)

VALUES(175,4,1,'PDA_OUT_VAR_EVER_BAD_30',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(176,4,1,'PDA_OUT_VAR_EVER_BAD_60',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(177,4,1,'PDA_OUT_VAR_EVER_BAD_90',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(178,4,1,'PDA_OUT_VAR_EVER_BAD_120',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(179,4,1,'PDA_OUT_VAR_EVER_BAD_180',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(180,4,1,'PDA_OUT_VAR_CURR_BAD_30',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(181,4,1,'PDA_OUT_VAR_CURR_BAD_60',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(182,4,1,'PDA_OUT_VAR_CURR_BAD_90',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(183,4,1,'PDA_OUT_VAR_CURR_BAD_120',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(184,4,1,'PDA_OUT_VAR_CURR_BAD_180',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(185,4,1,'PDA_OUT_EVER_CUSTOM_BAD',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(186,4,1,'PDA_OUT_CURR_CUSTOM_BAD',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(187,4,1,'PDA_OUT_VAR_COMPLEX_BAD_1',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(188,4,1,'PDA_OUT_VAR_COMPLEX_BAD_2',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(189,4,1,'LGD',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(193,3,3,'DEFAULT_DT',28,'spm_1_28_2224_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",1)

VALUES(194,1,1,'B_MAX_SNP_DAY_PAYP_L1M',1,'beh_7_3_1_20_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(195,1,1,'B_MAX_SNP_DAY_PAYP_1_12M',1,'beh_7_3_1_20_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(196,1,1,'B_MAX_SNP_DEF_CNT_L1M',1,'beh_7_3_1_27_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(197,1,1,'B_MAX_SNP_DEF_CNT_1_12M',1,'beh_7_3_1_27_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(198,1,1,'B_MAX_SNP_CHRG_OFC_1_12M',1,'beh_7_3_1_1434_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(199,1,1,'B_SUM_SNP_DPD120_1_12M',1,'beh_7_1_1_1593_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(200,1,1,'B_SUM_SNP_DPD180_1_12M',1,'beh_7_1_1_2220_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(201,1,1,'B_SUM_SNP_DPD30_1_12M',1,'beh_7_1_1_1431_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(202,1,1,'B_SUM_SNP_DPD60_1_12M',1,'beh_7_1_1_1432_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(203,1,1,'B_SUM_SNP_DPD90_1_12M',1,'beh_7_1_1_1433_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(204,1,1,'B_SUM_SNP_CHRG_OFC_1_12M',1,'beh_7_1_1_1434_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(205,1,1,'B_MAX_SNP_DAY_PAYP_L1M',1,'beh_7_3_1_20_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(206,1,1,'B_MAX_SNP_DAY_PAYP_1_12M',1,'beh_7_3_1_20_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(207,1,1,'B_MAX_SNP_DEF_CNT_L1M',1,'beh_7_3_1_27_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(208,1,1,'B_MAX_SNP_DEF_CNT_1_12M',1,'beh_7_3_1_27_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(209,1,1,'B_MAX_SNP_CHRG_OFC_1_12M',1,'beh_7_3_1_1434_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(210,1,1,'B_SUM_SNP_DPD120_1_12M',1,'beh_7_1_1_1593_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(211,1,1,'B_SUM_SNP_DPD180_1_12M',1,'beh_7_1_1_2220_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(212,1,1,'B_SUM_SNP_DPD30_1_12M',1,'beh_7_1_1_1431_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(213,1,1,'B_SUM_SNP_DPD60_1_12M',1,'beh_7_1_1_1432_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(214,1,1,'B_SUM_SNP_DPD90_1_12M',1,'beh_7_1_1_1433_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(215,1,1,'B_SUM_SNP_CHRG_OFC_1_12M',1,'beh_7_1_1_1434_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(216,1,1,'B_MAX_SNP_DAY_PAYP_1_12M',1,'beh_7_3_1_20_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(217,1,1,'B_MAX_SNP_DAY_PAYP_L1M',1,'beh_7_3_1_20_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(218,1,1,'B_MAX_SNP_DEF_CNT_1_12M',1,'beh_7_3_1_27_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(219,1,1,'B_MAX_SNP_DEF_CNT_L1M',1,'beh_7_3_1_27_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(220,1,1,'B_MAX_SNP_DAY_PAYP_1_12M',1,'beh_7_3_1_20_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(221,1,1,'B_MAX_SNP_DAY_PAYP_L1M',1,'beh_7_3_1_20_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(222,1,1,'B_MAX_SNP_DEF_CNT_1_12M',1,'beh_7_3_1_27_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(223,1,1,'B_MAX_SNP_DEF_CNT_L1M',1,'beh_7_3_1_27_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

;

quit;

proc sql;

insert into &csb_apdm_lib_ref..VARIABLE_MASTER (

VARIABLE_SK ,VARIABLE_TYPE_SK ,COLUMN_DATA_TYPE_SK ,VARIABLE_COLUMN_NM ,SOURCE_TABLE_SK ,VARIABLE_DEFINITION_STRING ,CREATED_DTTM ,CREATED_BY_USER ,LAST_PROCESSED_DTTM ,LAST_PROCESSED_BY_USER ,LEVEL_SK 

)

VALUES(224,1,1,'B_MAX_SNP_DAY_PAYP_L1M',1,'beh_7_3_1_20_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(225,1,1,'B_MAX_SNP_DAY_PAYP_1_12M',1,'beh_7_3_1_20_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(226,1,1,'B_MAX_SNP_DEF_CNT_L1M',1,'beh_7_3_1_27_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(227,1,1,'B_MAX_SNP_DEF_CNT_1_12M',1,'beh_7_3_1_27_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(228,1,1,'B_MAX_SNP_CHRG_OFC_1_12M',1,'beh_7_3_1_1434_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(229,1,1,'B_SUM_SNP_CHRG_OFC_1_12M',1,'beh_7_1_1_1434_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(230,1,1,'B_SUM_SNP_DPD120_1_12M',1,'beh_7_1_1_1593_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(231,1,1,'B_SUM_SNP_DPD180_1_12M',1,'beh_7_1_1_2220_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(232,1,1,'B_SUM_SNP_DPD30_1_12M',1,'beh_7_1_1_1431_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(233,1,1,'B_SUM_SNP_DPD90_1_12M',1,'beh_7_1_1_1433_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(234,1,1,'B_SUM_SNP_DPD60_1_12M',1,'beh_7_1_1_1432_6',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(235,4,1,'PDO_CRP_ACC_EVER_BAD_30',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(236,4,1,'PDO_CRP_ACC_EVER_BAD_60',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(237,4,1,'PDO_CRP_ACC_EVER_BAD_90',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(238,4,1,'PDO_CRP_ACC_EVER_BAD_120',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(239,4,1,'PDO_CRP_ACC_EVER_BAD_180',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(240,4,1,'PDO_CRP_ACC_CURR_BAD_30',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(241,4,1,'PDO_CRP_ACC_CURR_BAD_60',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(242,4,1,'PDO_CRP_ACC_CURR_BAD_90',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(243,4,1,'PDO_CRP_ACC_CURR_BAD_120',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(244,4,1,'PDO_CRP_ACC_CURR_BAD_180',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(245,4,1,'PDO_CRP_AC_EVER_CUSTOM_BAD',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(246,4,1,'PDO_CRP_AC_CURR_CUSTOM_BAD',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(247,4,1,'PDO_CRP_AC_EVER_CHARGED_OFF',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(248,4,1,'PDO_CRP_ACC_COMPLEX_BAD_1',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(249,4,1,'PDO_CRP_ACC_COMPLEX_BAD_2',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(250,3,3,'DEFAULT_DT',28,'spm_7_28_2224_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(251,3,3,'DEFAULT_DT',31,'spm_4_31_1586_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",4)

VALUES(253,3,2,'CUSTOMER_ID',11,'spm_5_11_529_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",5)

VALUES(300,3,3,'INPUT_DEFAULT_DT',28,'spm_1_28_2224_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",1)

VALUES(301,3,3,'INPUT_DEFAULT_DT',31,'spm_4_31_1586_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",4)

VALUES(302,3,3,'INPUT_DEFAULT_DT',28,'spm_7_28_2224_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(303,3,2,'DEFAULT_STATUS_CD',28,'spm_1_28_1567_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",1)

VALUES(304,3,2,'DEFAULT_STATUS_CD',31,'spm_4_31_1589_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",4)

VALUES(305,3,2,'DEFAULT_STATUS_CD',28,'spm_7_28_1567_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(306,1,1,'ACT_EAD',60,'beh_1_1_60_2864_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",1)

VALUES(307,1,1,'ACT_VALUE_AT_RECOVERY',60,'beh_1_1_60_2865_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",1)

VALUES(308,1,1,'ACT_RECOVERY_COST',60,'beh_1_1_60_2866_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",1)

VALUES(309,1,1,'ACT_EAD',60,'beh_7_1_60_2864_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(310,1,1,'ACT_VALUE_AT_RECOVERY',60,'beh_7_1_60_2865_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(311,1,1,'ACT_RECOVERY_COST',60,'beh_7_1_60_2866_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",7)

VALUES(312,1,1,'ACT_EAD',61,'beh_4_1_61_2873_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",4)

VALUES(313,1,1,'ACT_VALUE_AT_RECOVERY',61,'beh_4_1_61_2874_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",4)

VALUES(314,1,1,'ACT_RECOVERY_COST',61,'beh_4_1_61_2875_1',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",4)

VALUES(315,4,1,'ACT_LGD',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(316,4,1,'ACT_LGD',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

VALUES(317,4,1,'ACT_LGD',.,'',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid",.)

;

quit;



%include "&csb_script_path./csbmva_insert_script_modeling_abt_x_variable.sas";



proc sql;

insert into &csb_apdm_lib_ref..DERIVED_VARIABLE (

VARIABLE_SK ,DERIVED_VAR_CALC_EXPRESSION ,VARIABLE_SUB_TYPE_CD ,VARIABLE_LEVEL_NO

)

VALUES(22,'( CASE WHEN ( <<P_MAX_SNP_DAY_PAYP_1_12M>> >30 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(23,'( CASE WHEN ( <<P_MAX_SNP_DAY_PAYP_1_12M>> >60 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(26,'( CASE WHEN ( <<P_MAX_SNP_DAY_PAYP_1_12M>> >90 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(27,'( CASE WHEN ( <<P_MAX_SNP_DAY_PAYP_1_12M>> >120 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(28,'( CASE WHEN ( <<P_MAX_SNP_DAY_PAYP_1_12M>> >180 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(29,'( CASE WHEN ( <<P_MAX_SNP_DAY_PAYP_L1M>> >30 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(30,'( CASE WHEN ( <<P_MAX_SNP_DAY_PAYP_L1M>> >60 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(31,'( CASE WHEN ( <<P_MAX_SNP_DAY_PAYP_L1M>> >90 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(32,'( CASE WHEN ( <<P_MAX_SNP_DAY_PAYP_L1M>> >120 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(33,'( CASE WHEN ( <<P_MAX_SNP_DAY_PAYP_L1M>> >180 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(36,'( CASE WHEN ( <<P_MAX_SNP_DEF_CNT_1_12M>> >0 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(37,'( CASE WHEN ( <<P_MAX_SNP_DEF_CNT_L1M>> >0 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(44,'( CASE WHEN ( <<P_SUM_SNP_DPD30_1_12M>> >3 ) OR ( <<P_SUM_SNP_DPD60_1_12M>> >2 ) OR ( <<P_SUM_SNP_DPD90_1_12M>> >1 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(45,'( CASE WHEN ( <<P_SUM_SNP_DPD30_1_12M>> >3 ) OR ( <<P_SUM_SNP_DPD60_1_12M>> >2 ) OR ( <<P_SUM_SNP_DPD90_1_12M>> >1 ) OR ( <<P_SUM_SNP_CHRG_OFC_1_12M>> >0 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(48,'( CASE WHEN ( <<A_MAX_SNP_DAY_PAYP_1_12M>> >30 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(49,'( CASE WHEN ( <<A_MAX_SNP_DAY_PAYP_1_12M>> >60 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(50,'( CASE WHEN ( <<A_MAX_SNP_DAY_PAYP_1_12M>> >90 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(51,'( CASE WHEN ( <<A_MAX_SNP_DAY_PAYP_1_12M>> >120 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(52,'( CASE WHEN ( <<A_MAX_SNP_DAY_PAYP_1_12M>> >180 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(54,'( CASE WHEN ( <<A_MAX_SNP_DAY_PAYP_L1M>> >30 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(55,'( CASE WHEN ( <<A_MAX_SNP_DAY_PAYP_L1M>> >60 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(56,'( CASE WHEN ( <<A_MAX_SNP_DAY_PAYP_L1M>> >90 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(57,'( CASE WHEN ( <<A_MAX_SNP_DAY_PAYP_L1M>> >120 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(58,'( CASE WHEN ( <<A_MAX_SNP_DAY_PAYP_L1M>> >180 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(61,'( CASE WHEN ( <<A_MAX_SNP_DEF_CNT_1_12M>> >0 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(63,'( CASE WHEN ( <<A_MAX_SNP_DEF_CNT_L1M>> >0 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(65,'( CASE WHEN ( <<A_MAX_SNP_CHRG_OFC_1_12M>> >0 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(72,'( CASE WHEN ( <<A_SUM_SNP_DPD30_1_12M>> >3 ) OR ( <<A_SUM_SNP_DPD60_1_12M>> >2 ) OR ( <<A_SUM_SNP_DPD90_1_12M>> >1 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(73,'( CASE WHEN ( <<A_SUM_SNP_DPD30_1_12M>> >3 ) OR ( <<A_SUM_SNP_DPD60_1_12M>> >2 ) OR ( <<A_SUM_SNP_DPD90_1_12M>> >1 ) OR ( <<A_SUM_SNP_CHRG_OFC_1_12M>> >0 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(76,'( CASE WHEN ( <<I_MAX_SNP_DAY_PAYP_1_12M>> >30 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(77,'( CASE WHEN ( <<I_MAX_SNP_DAY_PAYP_1_12M>> >60 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(78,'( CASE WHEN ( <<I_MAX_SNP_DAY_PAYP_1_12M>> >90 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(79,'( CASE WHEN ( <<I_MAX_SNP_DAY_PAYP_1_12M>> >120 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(80,'( CASE WHEN ( <<I_MAX_SNP_DAY_PAYP_1_12M>> >180 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(81,'( CASE WHEN ( <<I_MAX_SNP_DAY_PAYP_L1M>> >30 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(82,'( CASE WHEN ( <<I_MAX_SNP_DAY_PAYP_L1M>> >60 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(83,'( CASE WHEN ( <<I_MAX_SNP_DAY_PAYP_L1M>> >90 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(84,'( CASE WHEN ( <<I_MAX_SNP_DAY_PAYP_L1M>> >120 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(85,'( CASE WHEN ( <<I_MAX_SNP_DAY_PAYP_L1M>> >180 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(89,'( CASE WHEN ( <<I_MAX_SNP_DEF_CNT_1_12M>> >0 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(91,'( CASE WHEN ( <<I_MAX_SNP_CHRG_OFC_1_12M>> >0 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(97,'( CASE WHEN ( <<I_MAX_SNP_DEF_CNT_L1M>> >0 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(98,'( CASE WHEN ( <<I_SUM_SNP_DPD30_1_12M>> >3 ) OR ( <<I_SUM_SNP_DPD60_1_12M>> >2 ) OR ( <<I_SUM_SNP_DPD90_1_12M>> >1 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(99,'( CASE WHEN ( <<I_SUM_SNP_DPD30_1_12M>> >3 ) OR ( <<I_SUM_SNP_DPD60_1_12M>> >2 ) OR ( <<I_SUM_SNP_DPD90_1_12M>> >1 ) OR ( <<I_MAX_SNP_CHRG_OFC_1_12M>> >0 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(110,'( CASE WHEN ( <<C_MAX_SNP_DAY_PAYP_1_12M>> >30 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(111,'( CASE WHEN ( <<C_MAX_SNP_DAY_PAYP_1_12M>> >60 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(112,'( CASE WHEN ( <<C_MAX_SNP_DAY_PAYP_1_12M>> >90 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(113,'( CASE WHEN ( <<C_MAX_SNP_DAY_PAYP_1_12M>> >120 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(114,'( CASE WHEN ( <<C_MAX_SNP_DAY_PAYP_1_12M>> >180 ) THEN 1 ELSE 0 END )','CPX',1)

;

quit;

proc sql;

insert into &csb_apdm_lib_ref..DERIVED_VARIABLE (

VARIABLE_SK ,DERIVED_VAR_CALC_EXPRESSION ,VARIABLE_SUB_TYPE_CD,VARIABLE_LEVEL_NO

)

VALUES(115,'( CASE WHEN ( <<C_MAX_SNP_DAY_PAYP_L1M>> >30 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(116,'( CASE WHEN ( <<C_MAX_SNP_DAY_PAYP_L1M>> >60 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(117,'( CASE WHEN ( <<C_MAX_SNP_DAY_PAYP_L1M>> >90 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(118,'( CASE WHEN ( <<C_MAX_SNP_DAY_PAYP_L1M>> >120 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(119,'( CASE WHEN ( <<C_MAX_SNP_DAY_PAYP_L1M>> >180 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(120,'( CASE WHEN ( <<C_MAX_SNP_DEF_CNT_1_12M>> >0 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(121,'( CASE WHEN ( <<C_MAX_SNP_DEF_CNT_L1M>> >0 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(122,'( CASE WHEN ( <<C_MAX_SNP_CHRG_OFC_1_12M>> >0 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(123,'( CASE WHEN ( <<C_SUM_SNP_DPD30_1_12M>> >3 ) OR ( <<C_SUM_SNP_DPD60_1_12M>> >2 ) OR ( <<C_SUM_SNP_DPD90_1_12M>> >1 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(124,'( CASE WHEN ( <<C_SUM_SNP_DPD30_1_12M>> >3 ) OR ( <<C_SUM_SNP_DPD60_1_12M>> >2 ) OR ( <<C_SUM_SNP_DPD90_1_12M>> >1 ) OR ( <<C_MAX_SNP_CHRG_OFC_1_12M>> >0 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(129,'(<<EAD>>+<<RECOVERY_COST>>-<<VALUE_AT_RECOVERY>>)/<<EAD>>','SPL',1)

VALUES(134,'(<<EAD>>+<<RECOVERY_COST>>-<<VALUE_AT_RECOVERY>>)/<<EAD>>','SPL',1)

VALUES(144,'(((<<SUM_TOT_BAL_L1M>>*<<SUM_CUR_LIMIT_AMT_12MB>>)/<<SUM_CUR_LIMIT_AMT_L1M>>)-<<AVG_TOT_BAL_13_24M>>)/(<<SUM_CUR_LIMIT_AMT_L1M>>-<<AVG_TOT_BAL_13_24M>>)','SPL',1)

VALUES(149,'(((<<SUM_TOT_BAL_L1M>>*<<SUM_CUR_LIMIT_AMT_12MB>>)/<<SUM_CUR_LIMIT_AMT_L1M>>)-<<AVG_TOT_BAL_13_24M>>)/(<<SUM_CUR_LIMIT_AMT_L1M>>-<<AVG_TOT_BAL_13_24M>>)','SPL',1)

VALUES(175,'( CASE WHEN ( <<Q_MAX_SNP_DAY_PAYP_1_12M>> >30 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(176,'( CASE WHEN ( <<Q_MAX_SNP_DAY_PAYP_1_12M>> >60 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(177,'( CASE WHEN ( <<Q_MAX_SNP_DAY_PAYP_1_12M>> >90 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(178,'( CASE WHEN ( <<Q_MAX_SNP_DAY_PAYP_1_12M>> >120 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(179,'( CASE WHEN ( <<Q_MAX_SNP_DAY_PAYP_1_12M>> >180 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(180,'( CASE WHEN ( <<Q_MAX_SNP_DAY_PAYP_L1M>> >30 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(181,'( CASE WHEN ( <<Q_MAX_SNP_DAY_PAYP_L1M>> >60 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(182,'( CASE WHEN ( <<Q_MAX_SNP_DAY_PAYP_L1M>> >90 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(183,'( CASE WHEN ( <<Q_MAX_SNP_DAY_PAYP_L1M>> >120 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(184,'( CASE WHEN ( <<Q_MAX_SNP_DAY_PAYP_L1M>> >180 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(185,'( CASE WHEN ( <<Q_MAX_SNP_DEF_CNT_1_12M>> >0 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(186,'( CASE WHEN ( <<Q_MAX_SNP_DEF_CNT_L1M>> >0 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(187,'( CASE WHEN ( <<Q_SUM_SNP_DPD30_1_12M>> >3 ) OR ( <<Q_SUM_SNP_DPD60_1_12M>> >2 ) OR ( <<Q_SUM_SNP_DPD90_1_12M>> >1 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(188,'( CASE WHEN ( <<Q_SUM_SNP_DPD30_1_12M>> >3 ) OR ( <<Q_SUM_SNP_DPD60_1_12M>> >2 ) OR ( <<Q_SUM_SNP_DPD90_1_12M>> >1 ) OR ( <<Q_SUM_SNP_CHRG_OFC_1_12M>> >0 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(189,'(<<EAD>>+<<RECOVERY_COST>>-<<VALUE_AT_RECOVERY>>)/<<EAD>>','SPL',1)

VALUES(235,'( CASE WHEN ( <<B_MAX_SNP_DAY_PAYP_1_12M>> >30 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(236,'( CASE WHEN ( <<B_MAX_SNP_DAY_PAYP_1_12M>> >60 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(237,'( CASE WHEN ( <<B_MAX_SNP_DAY_PAYP_1_12M>> >90 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(238,'( CASE WHEN ( <<B_MAX_SNP_DAY_PAYP_1_12M>> >120 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(239,'( CASE WHEN ( <<B_MAX_SNP_DAY_PAYP_1_12M>> >180 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(240,'( CASE WHEN ( <<B_MAX_SNP_DAY_PAYP_L1M>> >30 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(241,'( CASE WHEN ( <<B_MAX_SNP_DAY_PAYP_L1M>> >60 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(242,'( CASE WHEN ( <<B_MAX_SNP_DAY_PAYP_L1M>> >90 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(243,'( CASE WHEN ( <<B_MAX_SNP_DAY_PAYP_L1M>> >120 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(244,'( CASE WHEN ( <<B_MAX_SNP_DAY_PAYP_L1M>> >180 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(245,'( CASE WHEN ( <<B_MAX_SNP_DEF_CNT_1_12M>> >0 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(246,'( CASE WHEN ( <<B_MAX_SNP_DEF_CNT_L1M>> >0 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(247,'( CASE WHEN ( <<B_MAX_SNP_CHRG_OFC_1_12M>> >0 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(248,'( CASE WHEN ( <<B_SUM_SNP_DPD30_1_12M>> >3 ) OR ( <<B_SUM_SNP_DPD60_1_12M>> >2 ) OR ( <<B_SUM_SNP_DPD90_1_12M>> >1 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(249,'( CASE WHEN ( <<B_SUM_SNP_DPD30_1_12M>> >3 ) OR ( <<B_SUM_SNP_DPD60_1_12M>> >2 ) OR ( <<B_SUM_SNP_DPD90_1_12M>> >1 ) OR ( <<B_SUM_SNP_CHRG_OFC_1_12M>> >0 ) THEN 1 ELSE 0 END )','CPX',1)

VALUES(315,'(<<ACT_EAD>>+<<ACT_RECOVERY_COST>>-<<ACT_VALUE_AT_RECOVERY>>)/<<ACT_EAD>>','SPL',1)

VALUES(316,'(<<ACT_EAD>>+<<ACT_RECOVERY_COST>>-<<ACT_VALUE_AT_RECOVERY>>)/<<ACT_EAD>>','SPL',1)

VALUES(317,'(<<ACT_EAD>>+<<ACT_RECOVERY_COST>>-<<ACT_VALUE_AT_RECOVERY>>)/<<ACT_EAD>>','SPL',1)

;

quit;



proc sql;

insert into &csb_apdm_lib_ref..SUPPLEMENTARY_VARIABLE (

VARIABLE_SK ,SELECT_SOURCE_COLUMN_SK, AS_OF_TIME_SK

)

VALUES(1,1317,1)

VALUES(12,1317,1)

VALUES(46,1745,1)

VALUES(150,736,1)

VALUES(151,529,1)

VALUES(152,736,1)

VALUES(153,529,1)

VALUES(154,1400,1)

VALUES(155,736,1)

VALUES(156,529,1)

VALUES(157,1400,1)

VALUES(158,736,1)

VALUES(159,529,1)

VALUES(160,1400,1)

VALUES(164,1745,1)

VALUES(250,2224,1)

VALUES(251,1586,1)

VALUES(253,529,1)

VALUES(193,2224,1)

VALUES(300,2224,1)

VALUES(301,1586,1)

VALUES(302,2224,1)

VALUES(303,1567,1)

VALUES(304,1589,1)

VALUES(305,1567,1)

;

quit;

proc sql;

insert into &csb_apdm_lib_ref..BEHAVIORAL_VARIABLE (

VARIABLE_SK ,MEASURE_SOURCE_COLUMN_SK ,AGGREGATION_TYPE_SK ,TIME_PERIOD_SK 

)

VALUES(13,20,3,6)

VALUES(20,20,3,1)

VALUES(34,27,3,6)

VALUES(35,27,3,1)

VALUES(38,1431,1,6)

VALUES(39,1432,1,6)

VALUES(40,1433,1,6)

VALUES(41,1593,1,6)

VALUES(42,2220,1,6)

VALUES(43,1434,1,6)

VALUES(47,20,3,6)

VALUES(53,20,3,1)

VALUES(59,27,3,6)

VALUES(60,27,3,1)

VALUES(64,1434,3,6)

VALUES(66,1431,1,6)

VALUES(67,1432,1,6)

VALUES(68,1433,1,6)

VALUES(69,1593,1,6)

VALUES(70,2220,1,6)

VALUES(71,1434,1,6)

VALUES(74,20,3,6)

VALUES(75,20,3,1)

VALUES(86,27,3,6)

VALUES(87,27,3,1)

VALUES(88,1434,3,6)

VALUES(92,1431,1,6)

VALUES(93,1432,1,6)

VALUES(94,1433,1,6)

VALUES(95,2220,1,6)

VALUES(96,1593,1,6)

VALUES(100,20,3,6)

VALUES(101,20,3,1)

VALUES(102,27,3,6)

VALUES(103,27,3,1)

VALUES(104,1434,3,6)

VALUES(105,1431,1,6)

VALUES(106,1432,1,6)

VALUES(107,1433,1,6)

VALUES(108,1593,1,6)

VALUES(109,2220,1,6)

VALUES(126,1572,1,1)

VALUES(127,1573,1,1)

VALUES(128,1574,1,1)

VALUES(131,1572,1,1)

VALUES(132,1573,1,1)

VALUES(133,1574,1,1)

VALUES(135,1579,1,1)

;

quit;

proc sql;

insert into &csb_apdm_lib_ref..BEHAVIORAL_VARIABLE (

VARIABLE_SK ,MEASURE_SOURCE_COLUMN_SK ,AGGREGATION_TYPE_SK ,TIME_PERIOD_SK 

)

VALUES(136,1580,1,1)

VALUES(137,1581,1,1)

VALUES(140,80,1,1)

VALUES(141,77,1,1)

VALUES(142,77,1,13)

VALUES(143,80,2,3)

VALUES(145,80,1,1)

VALUES(146,77,1,1)

VALUES(147,80,2,3)

VALUES(148,77,1,13)

VALUES(165,20,3,6)

VALUES(166,20,3,1)

VALUES(167,27,3,6)

VALUES(168,27,3,1)

VALUES(169,1431,1,6)

VALUES(170,2220,1,6)

VALUES(171,1593,1,6)

VALUES(172,1432,1,6)

VALUES(173,1433,1,6)

VALUES(174,1434,1,6)

VALUES(224,20,3,1)

VALUES(225,20,3,6)

VALUES(226,27,3,1)

VALUES(227,27,3,6)

VALUES(228,1434,3,6)

VALUES(229,1434,1,6)

VALUES(230,1593,1,6)

VALUES(231,2220,1,6)

VALUES(232,1431,1,6)

VALUES(233,1433,1,6)

VALUES(234,1432,1,6)

VALUES(306,2864,1,1)

VALUES(307,2865,1,1)

VALUES(308,2866,1,1)

VALUES(309,2864,1,1)

VALUES(310,2865,1,1)

VALUES(311,2866,1,1)

VALUES(312,2873,1,1)

VALUES(313,2874,1,1)

VALUES(314,2875,1,1)

;

quit;



proc sql;

insert into &csb_apdm_lib_ref..DERIVED_VAR_X_EXPRESSION_VAR (

EXPRESSION_VARIABLE_SK ,DERIVED_VARIABLE_SK 

)

VALUES(13,22)

VALUES(13,23)

VALUES(13,26)

VALUES(13,27)

VALUES(13,28)

VALUES(20,29)

VALUES(20,30)

VALUES(20,31)

VALUES(20,32)

VALUES(20,33)

VALUES(34,36)

VALUES(35,37)

VALUES(38,44)

VALUES(39,44)

VALUES(40,44)

VALUES(38,45)

VALUES(39,45)

VALUES(40,45)

VALUES(43,45)

VALUES(47,48)

VALUES(47,49)

VALUES(47,50)

VALUES(47,51)

VALUES(47,52)

VALUES(53,54)

VALUES(53,55)

VALUES(53,56)

VALUES(53,57)

VALUES(53,58)

VALUES(59,61)

VALUES(60,63)

VALUES(64,65)

VALUES(66,72)

VALUES(67,72)

VALUES(68,72)

VALUES(66,73)

VALUES(67,73)

VALUES(68,73)

VALUES(71,73)

VALUES(74,76)

VALUES(74,77)

VALUES(74,78)

VALUES(74,79)

VALUES(74,80)

VALUES(75,81)

VALUES(75,82)

VALUES(75,83)

VALUES(75,84)

VALUES(75,85)

;

quit;

proc sql;

insert into &csb_apdm_lib_ref..DERIVED_VAR_X_EXPRESSION_VAR (

EXPRESSION_VARIABLE_SK ,DERIVED_VARIABLE_SK 

)

VALUES(86,89)

VALUES(88,91)

VALUES(87,97)

VALUES(92,98)

VALUES(93,98)

VALUES(94,98)

VALUES(92,99)

VALUES(93,99)

VALUES(94,99)

VALUES(88,99)

VALUES(100,110)

VALUES(100,111)

VALUES(100,112)

VALUES(100,113)

VALUES(100,114)

VALUES(101,115)

VALUES(101,116)

VALUES(101,117)

VALUES(101,118)

VALUES(101,119)

VALUES(102,120)

VALUES(103,121)

VALUES(104,122)

VALUES(105,123)

VALUES(106,123)

VALUES(107,123)

VALUES(105,124)

VALUES(106,124)

VALUES(107,124)

VALUES(104,124)

VALUES(126,129)

VALUES(128,129)

VALUES(127,129)

VALUES(131,134)

VALUES(133,134)

VALUES(132,134)

VALUES(140,144)

VALUES(142,144)

VALUES(141,144)

VALUES(143,144)

VALUES(145,149)

VALUES(148,149)

VALUES(146,149)

VALUES(147,149)

VALUES(165,175)

VALUES(165,176)

VALUES(165,177)

VALUES(165,178)

VALUES(165,179)

VALUES(166,180)

;

quit;

proc sql;

insert into &csb_apdm_lib_ref..DERIVED_VAR_X_EXPRESSION_VAR (

EXPRESSION_VARIABLE_SK ,DERIVED_VARIABLE_SK 

)

VALUES(166,181)

VALUES(166,182)

VALUES(166,183)

VALUES(166,184)

VALUES(167,185)

VALUES(168,186)

VALUES(169,187)

VALUES(172,187)

VALUES(173,187)

VALUES(169,188)

VALUES(172,188)

VALUES(173,188)

VALUES(174,188)

VALUES(135,189)

VALUES(137,189)

VALUES(136,189)

VALUES(225,235)

VALUES(225,236)

VALUES(225,237)

VALUES(225,238)

VALUES(225,239)

VALUES(224,240)

VALUES(224,241)

VALUES(224,242)

VALUES(224,243)

VALUES(224,244)

VALUES(227,245)

VALUES(226,246)

VALUES(228,247)

VALUES(232,248)

VALUES(234,248)

VALUES(233,248)

VALUES(232,249)

VALUES(234,249)

VALUES(233,249)

VALUES(229,249)

VALUES(306,315)

VALUES(307,315)

VALUES(308,315)

VALUES(309,316)

VALUES(310,316)

VALUES(311,316)

VALUES(312,317)

VALUES(313,317)

VALUES(314,317)

;

quit;



proc sql;

insert into &csb_apdm_lib_ref..IMPLICIT_VAR_SPECIFICATION_DTL (

PURPOSE_SK ,LEVEL_SK ,ABT_TIME_GRAIN_SK ,VARIABLE_SK ,MDL_ABT_OUTCOME_VARIABLE_FLG ,APPLICABLE_FOR_SCR_PROCESS_FLG ,APPLICABLE_FOR_ACT_PROCESS_FLG ,CREATED_DTTM ,CREATED_BY_USER ,LAST_PROCESSED_DTTM ,LAST_PROCESSED_BY_USER 

)

VALUES(101,3,1,1,'N','N','N',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(101,8,1,46,'N','N','N',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(101,3,1,150,'N','N','N',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(101,8,1,151,'N','N','N',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(101,1,1,152,'N','N','N',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(101,7,1,153,'N','N','N',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(101,7,1,154,'N','N','N',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,1,1,155,'N','N','N',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,7,1,156,'N','N','N',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,7,1,157,'N','N','N',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(103,1,1,158,'N','N','N',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(103,7,1,159,'N','N','N',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(103,7,1,160,'N','N','N',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,4,1,253,'N','N','N',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,1,1,126,'Y','N','N',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,1,1,127,'Y','N','N',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,1,1,128,'Y','N','N',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,1,1,129,'Y','N','N',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,7,1,131,'Y','N','N',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,7,1,132,'Y','N','N',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,7,1,133,'Y','N','N',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,7,1,134,'Y','N','N',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,4,1,135,'Y','N','N',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,4,1,136,'Y','N','N',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,4,1,137,'Y','N','N',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,4,1,189,'Y','N','N',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,1,1,193,'Y','N','Y',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,7,1,250,'Y','N','Y',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,4,1,251,'Y','N','Y',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,1,1,300,'N','N','N',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,4,1,301,'N','N','N',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,7,1,302,'N','N','N',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,1,1,303,'N','N','N',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,4,1,304,'N','N','N',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,7,1,305,'N','N','N',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,1,1,306,'N','N','Y',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,1,1,307,'N','N','Y',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,1,1,308,'N','N','Y',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,7,1,309,'N','N','Y',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,7,1,310,'N','N','Y',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,7,1,311,'N','N','Y',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,4,1,312,'N','N','Y',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,4,1,313,'N','N','Y',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,4,1,314,'N','N','Y',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,1,1,315,'N','N','Y',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,7,1,316,'N','N','Y',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,4,1,317,'N','N','Y',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

;

quit;



proc sql;

insert into &csb_apdm_lib_ref..IMPLICIT_VAR_SPECIFICATION_DTL (

PURPOSE_SK ,LEVEL_SK ,ABT_TIME_GRAIN_SK ,VARIABLE_SK ,MDL_ABT_OUTCOME_VARIABLE_FLG ,APPLICABLE_FOR_SCR_PROCESS_FLG ,APPLICABLE_FOR_ACT_PROCESS_FLG ,CREATED_DTTM ,CREATED_BY_USER ,LAST_PROCESSED_DTTM ,LAST_PROCESSED_BY_USER 

)

VALUES(101,3,2,1,'N','N','N',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(101,8,2,46,'N','N','N',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(101,3,2,150,'N','N','N',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(101,8,2,151,'N','N','N',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(101,1,2,152,'N','N','N',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(101,7,2,153,'N','N','N',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(101,7,2,154,'N','N','N',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(102,1,2,155,'N','N','N',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(102,7,2,156,'N','N','N',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(102,7,2,157,'N','N','N',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(103,1,2,158,'N','N','N',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(103,7,2,159,'N','N','N',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(103,7,2,160,'N','N','N',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(102,4,2,253,'N','N','N',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(102,1,2,126,'Y','N','N',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(102,1,2,127,'Y','N','N',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(102,1,2,128,'Y','N','N',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(102,1,2,129,'Y','N','N',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(102,7,2,131,'Y','N','N',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(102,7,2,132,'Y','N','N',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(102,7,2,133,'Y','N','N',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(102,7,2,134,'Y','N','N',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(102,4,2,135,'Y','N','N',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(102,4,2,136,'Y','N','N',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(102,4,2,137,'Y','N','N',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(102,4,2,189,'Y','N','N',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(102,1,2,193,'Y','N','Y',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(102,7,2,250,'Y','N','Y',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(102,4,2,251,'Y','N','Y',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(102,1,2,300,'N','N','N',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(102,4,2,301,'N','N','N',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(102,7,2,302,'N','N','N',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(102,1,2,303,'N','N','N',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(102,4,2,304,'N','N','N',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(102,7,2,305,'N','N','N',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(102,1,2,306,'Y','N','Y',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(102,1,2,307,'Y','N','Y',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(102,1,2,308,'Y','N','Y',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(102,7,2,309,'Y','N','Y',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(102,7,2,310,'Y','N','Y',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(102,7,2,311,'Y','N','Y',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(102,4,2,312,'Y','N','Y',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(102,4,2,313,'Y','N','Y',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(102,4,2,314,'Y','N','Y',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(102,1,2,315,'Y','N','Y',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(102,7,2,316,'Y','N','Y',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

VALUES(102,4,2,317,'Y','N','Y',"%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid","%sysfunc(datetime(),DATETIME.)"dt,"&sysuserid")

;

quit;





%include "&csb_script_path./csbmva_insert_script_subset_query_master.sas";





%include "&csb_script_path./csbmva_insert_script_subject_group_master.sas";





proc sql;

insert into &csb_apdm_lib_ref..SUBJECT_GROUP_SPCFCN_DTL (

PURPOSE_SK ,LEVEL_SK ,SUBJECT_GROUP_SK ,CREATED_DTTM ,CREATED_BY_USER ,LAST_PROCESSED_DTTM ,LAST_PROCESSED_BY_USER 

)

VALUES(101,3,7,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(101,3,8,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(101,3,9,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,1,11,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,1,12,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,1,13,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(103,1,14,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,7,15,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,7,16,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,4,18,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,4,19,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,4,20,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(101,8,21,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(101,8,22,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(101,7,24,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(101,7,25,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(101,1,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(101,1,2,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(101,1,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(101,1,4,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

;

quit;



proc sql;

insert into &csb_apdm_lib_ref..IMPLICIT_SUBSET_SPCFCTN_DTL (

PURPOSE_SK ,LEVEL_SK ,APPLICABLE_FOR_PROCESS_TYPE_CD ,SUBSET_QUERY_SK ,CREATED_DTTM ,CREATED_BY_USER ,LAST_PROCESSED_DTTM ,LAST_PROCESSED_BY_USER 

)

VALUES(101,1,'MDL',18,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,1,'MDL',43,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(103,1,'MDL',61,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(101,2,'MDL',32,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(101,3,'MDL',2,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,4,'MDL',76,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(101,5,'MDL',37,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(101,7,'MDL',25,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,7,'MDL',52,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(103,7,'MDL',65,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(101,8,'MDL',11,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")


/*
VALUES(101,1,'PLG',18,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,1,'PLG',43,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(103,1,'PLG',61,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(101,2,'PLG',32,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(101,3,'PLG',2,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,4,'PLG',76,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(101,5,'PLG',37,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(101,7,'PLG',25,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,7,'PLG',52,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(103,7,'PLG',65,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(101,8,'PLG',11,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")
*/


VALUES(101,1,'SCR',20,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,1,'SCR',45,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(103,1,'SCR',63,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(101,2,'SCR',34,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(101,3,'SCR',4,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,4,'SCR',78,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(101,5,'SCR',39,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(101,7,'SCR',27,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,7,'SCR',54,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(103,7,'SCR',70,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(101,8,'SCR',13,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")


/*
VALUES(101,1,'BCK',151,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,1,'BCK',152,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(103,1,'BCK',153,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(101,2,'BCK',154,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(101,3,'BCK',155,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,4,'BCK',156,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(101,5,'BCK',157,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(101,7,'BCK',158,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,7,'BCK',159,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(103,7,'BCK',160,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(101,8,'BCK',161,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")
*/
;

quit;


%include "&csb_script_path./csbmva_insert_script_subset_filter_node.sas";


/*SUBSET_FILTER_NODE_EXPRESSION */

proc sql;

insert into &csb_apdm_lib_ref..SUBSET_FILTER_NODE_EXPRESSION (

SUBSET_QUERY_SK ,SUBSET_FILTER_NODE_SK ,SUBSET_FILTER_NODE_EXPRSSN_SK ,FILTER_NODE_EXPRSSN_SQNC_NUM ,MULTI_CONDTN_BOOLEAN_OPRTR_VAL ,OPERAND_SOURCE_COLUMN_SK ,OPERATOR_SK ,USER_ENTERED_VALUE_FLG ,USER_ENTERED_VALUE_TXT ,CREATED_DTTM ,CREATED_BY_USER ,

LAST_PROCESSED_DTTM ,LAST_PROCESSED_BY_USER 

)

VALUES(37,3,1,1,'',538,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(39,3,1,1,'',538,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(39,2,1,1,'',540,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(32,3,1,1,'',745,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(34,3,1,1,'',745,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(32,2,2,2,'AND',747,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(34,2,1,1,'',747,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(18,2,2,2,'AND',1215,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(20,2,1,1,'',1215,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(22,2,2,2,'AND',1215,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(23,2,2,2,'AND',1215,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(79,2,2,2,'AND',1215,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(80,2,2,2,'AND',1215,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(82,2,2,2,'AND',1215,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(84,2,2,2,'AND',1215,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(86,2,2,2,'AND',1215,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(2,2,1,1,'',1288,5,'Y','%dabt_intnx(''month'',&RUN_DATE,-&APPL_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(2,2,2,2,'AND',1288,6,'Y','%dabt_intnx(''month'',&RUN_DATE,0,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(3,2,1,1,'',1288,5,'Y','%dabt_intnx(''month'',&RUN_DATE,-&APPL_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(3,2,2,2,'AND',1288,6,'Y','%dabt_intnx(''month'',&RUN_DATE,0,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(4,2,2,1,'',1288,5,'Y','%dabt_intnx(''month'',&RUN_DATE,0,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(4,2,3,2,'AND',1288,6,'Y','%dabt_intnx(''month'',&RUN_DATE,0,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(5,2,1,1,'',1288,5,'Y','%dabt_intnx(''month'',&RUN_DATE,-&APPL_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(5,2,2,2,'AND',1288,6,'Y','%dabt_intnx(''month'',&RUN_DATE,0,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(7,2,1,1,'',1288,5,'Y','%dabt_intnx(''month'',&RUN_DATE,-&APPL_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(7,2,2,2,'AND',1288,6,'Y','%dabt_intnx(''month'',&RUN_DATE,0,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(8,2,1,1,'',1288,5,'Y','%dabt_intnx(''month'',&RUN_DATE,-&APPL_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(8,2,2,2,'AND',1288,6,'Y','%dabt_intnx(''month'',&RUN_DATE,0,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(9,2,1,1,'',1288,5,'Y','%dabt_intnx(''month'',&RUN_DATE,-&APPL_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(9,2,2,2,'AND',1288,6,'Y','%dabt_intnx(''month'',&RUN_DATE,0,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(92,2,1,1,'',1288,5,'Y','%dabt_intnx(''month'',&RUN_DATE,-&APPL_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(92,2,2,2,'AND',1288,6,'Y','%dabt_intnx(''month'',&RUN_DATE,0,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(94,2,1,1,'',1288,5,'Y','%dabt_intnx(''month'',&RUN_DATE,-&APPL_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(94,2,2,2,'AND',1288,6,'Y','%dabt_intnx(''month'',&RUN_DATE,0,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(96,2,1,1,'',1288,5,'Y','%dabt_intnx(''month'',&RUN_DATE,-&APPL_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(96,2,2,2,'AND',1288,6,'Y','%dabt_intnx(''month'',&RUN_DATE,0,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(2,4,1,1,'',1289,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(4,3,1,1,'',1289,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(92,4,1,1,'',1289,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(94,4,1,1,'',1289,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(96,4,1,1,'',1289,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(93,2,1,1,'',1549,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(95,2,1,1,'',1549,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(97,2,1,1,'',1549,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(43,3,1,1,'',1562,6,'Y','%dabt_intnx(''month'',&RUN_DATE,-&MOB,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(52,6,1,1,'',1562,6,'Y','%dabt_intnx(''month'',&RUN_DATE,-&MOB,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(61,5,1,1,'',1562,6,'Y','%dabt_intnx(''month'',&RUN_DATE,-&MOB,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(65,7,1,1,'',1562,6,'Y','%dabt_intnx(''month'',&RUN_DATE,-&MOB,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,3,1,1,'',1562,6,'Y','%dabt_intnx(''month'',&RUN_DATE,-&MOB,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(106,3,1,1,'',1562,6,'Y','%dabt_intnx(''month'',&RUN_DATE,-&MOB,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(107,6,1,1,'',1562,6,'Y','%dabt_intnx(''month'',&RUN_DATE,-&MOB,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(108,5,1,1,'',1562,6,'Y','%dabt_intnx(''month'',&RUN_DATE,-&MOB,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(109,7,1,1,'',1562,6,'Y','%dabt_intnx(''month'',&RUN_DATE,-&MOB,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(110,3,1,1,'',1562,6,'Y','%dabt_intnx(''month'',&RUN_DATE,-&MOB,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(112,3,1,1,'',1562,6,'Y','%dabt_intnx(''month'',&RUN_DATE,-&MOB,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(115,5,1,1,'',1562,6,'Y','%dabt_intnx(''month'',&RUN_DATE,-&MOB,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(117,5,1,1,'',1562,6,'Y','%dabt_intnx(''month'',&RUN_DATE,-&MOB,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(118,6,1,1,'',1562,6,'Y','%dabt_intnx(''month'',&RUN_DATE,-&MOB,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(121,6,1,1,'',1562,6,'Y','%dabt_intnx(''month'',&RUN_DATE,-&MOB,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(123,6,1,1,'',1562,6,'Y','%dabt_intnx(''month'',&RUN_DATE,-&MOB,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(143,7,1,1,'',1562,6,'Y','%dabt_intnx(''month'',&RUN_DATE,-&MOB,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(43,5,1,1,'',1563,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(45,2,1,1,'',1563,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(52,5,1,1,'',1563,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(54,2,1,1,'',1563,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(61,4,1,1,'',1563,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(63,2,1,1,'',1563,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(65,6,1,1,'',1563,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(70,2,1,1,'',1563,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,5,1,1,'',1563,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(106,5,1,1,'',1563,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(107,5,1,1,'',1563,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(108,4,1,1,'',1563,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(109,6,1,1,'',1563,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(110,5,1,1,'',1563,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(112,5,1,1,'',1563,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(115,4,1,1,'',1563,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(117,4,1,1,'',1563,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(118,5,1,1,'',1563,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(121,5,1,1,'',1563,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(123,5,1,1,'',1563,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(143,6,1,1,'',1563,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(43,4,1,1,'',1567,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(52,2,1,1,'',1567,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(61,2,1,1,'',1567,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(65,2,1,1,'',1567,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,4,1,1,'',1567,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(106,4,1,1,'',1567,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(107,2,1,1,'',1567,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(108,2,1,1,'',1567,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(109,2,1,1,'',1567,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(110,4,1,1,'',1567,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(112,4,1,1,'',1567,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(115,2,1,1,'',1567,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(117,2,1,1,'',1567,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(118,2,1,1,'',1567,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(121,2,1,1,'',1567,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(123,2,1,1,'',1567,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(143,2,1,1,'',1567,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(76,2,1,1,'',1586,1,'Y','.',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(76,3,1,1,'',1586,5,'Y','%dabt_intnx(''month'', &RUN_DATE,-&DEFAULT_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(76,3,2,2,'AND',1586,6,'Y','%dabt_intnx(''month'', &RUN_DATE,0,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(78,2,1,1,'',1586,1,'Y','.',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(104,2,1,1,'',1586,1,'Y','.',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(104,3,1,1,'',1586,5,'Y','%dabt_intnx(''month'', &RUN_DATE,-&DEFAULT_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(104,3,2,2,'AND',1586,6,'Y','%dabt_intnx(''month'', &RUN_DATE,0,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(105,2,1,1,'',1586,1,'Y','.',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(105,3,1,1,'',1586,5,'Y','%dabt_intnx(''month'', &RUN_DATE,-&DEFAULT_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(105,3,2,2,'AND',1586,6,'Y','%dabt_intnx(''month'', &RUN_DATE,0,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(125,2,1,1,'',1586,1,'Y','.',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(125,3,1,1,'',1586,5,'Y','%dabt_intnx(''month'', &RUN_DATE,-&DEFAULT_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(125,3,2,2,'AND',1586,6,'Y','%dabt_intnx(''month'', &RUN_DATE,0,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(127,2,1,1,'',1586,1,'Y','.',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(127,3,1,1,'',1586,5,'Y','%dabt_intnx(''month'', &RUN_DATE,-&DEFAULT_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(127,3,2,2,'AND',1586,6,'Y','%dabt_intnx(''month'', &RUN_DATE,0,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(129,2,1,1,'',1586,1,'Y','.',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(129,3,1,1,'',1586,5,'Y','%dabt_intnx(''month'', &RUN_DATE,-&DEFAULT_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(129,3,2,2,'AND',1586,6,'Y','%dabt_intnx(''month'', &RUN_DATE,0,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(138,2,1,1,'',1603,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(140,2,1,1,'',1603,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(25,3,1,1,'',1616,6,'Y','%dabt_intnx(''month'', &RUN_DATE, -&MOB ,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(88,3,1,1,'',1616,6,'Y','%dabt_intnx(''month'', &RUN_DATE, -&MOB ,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(90,3,1,1,'',1616,6,'Y','%dabt_intnx(''month'', &RUN_DATE, -&MOB ,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(137,3,1,1,'',1616,6,'Y','%dabt_intnx(''month'', &RUN_DATE, -&MOB ,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(139,3,1,1,'',1616,6,'Y','%dabt_intnx(''month'', &RUN_DATE, -&MOB ,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(141,3,1,1,'',1616,6,'Y','%dabt_intnx(''month'', &RUN_DATE, -&MOB ,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(27,2,1,1,'',1654,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(25,3,2,2,'AND',1654,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(88,3,2,2,'AND',1654,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(90,3,2,2,'AND',1654,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(137,3,2,2,'AND',1654,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(139,3,2,2,'AND',1654,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(141,3,2,2,'AND',1654,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(11,2,1,1,'',1716,5,'Y','%dabt_intnx(''month'',&RUN_DATE,-&APPL_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(11,2,2,2,'AND',1716,6,'Y','%dabt_intnx(''month'',&RUN_DATE,0,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(12,2,1,1,'',1716,5,'Y','%dabt_intnx(''month'',&RUN_DATE,-&APPL_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(12,2,2,2,'AND',1716,6,'Y','%dabt_intnx(''month'',&RUN_DATE,0,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(13,2,1,1,'',1716,5,'Y','%dabt_intnx(''month'',&RUN_DATE,0,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(13,2,2,2,'AND',1716,6,'Y','%dabt_intnx(''month'',&RUN_DATE,0,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(15,2,1,1,'',1716,5,'Y','%dabt_intnx(''month'',&RUN_DATE,-&APPL_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(15,2,2,2,'AND',1716,6,'Y','%dabt_intnx(''month'',&RUN_DATE,0,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(16,2,1,1,'',1716,5,'Y','%dabt_intnx(''month'',&RUN_DATE,-&APPL_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(16,2,2,2,'AND',1716,6,'Y','%dabt_intnx(''month'',&RUN_DATE,0,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(74,2,1,1,'',1716,5,'Y','%dabt_intnx(''month'',&RUN_DATE,-&APPL_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(74,2,2,2,'AND',1716,6,'Y','%dabt_intnx(''month'',&RUN_DATE,0,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(98,2,1,1,'',1716,5,'Y','%dabt_intnx(''month'',&RUN_DATE,-&APPL_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(98,2,2,2,'AND',1716,6,'Y','%dabt_intnx(''month'',&RUN_DATE,0,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(100,2,1,1,'',1716,5,'Y','%dabt_intnx(''month'',&RUN_DATE,-&APPL_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(100,2,2,2,'AND',1716,6,'Y','%dabt_intnx(''month'',&RUN_DATE,0,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(131,2,1,1,'',1716,5,'Y','%dabt_intnx(''month'',&RUN_DATE,-&APPL_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(131,2,2,2,'AND',1716,6,'Y','%dabt_intnx(''month'',&RUN_DATE,0,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(133,2,1,1,'',1716,5,'Y','%dabt_intnx(''month'',&RUN_DATE,-&APPL_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(133,2,2,2,'AND',1716,6,'Y','%dabt_intnx(''month'',&RUN_DATE,0,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(135,2,1,1,'',1716,5,'Y','%dabt_intnx(''month'',&RUN_DATE,-&APPL_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(135,2,2,2,'AND',1716,6,'Y','%dabt_intnx(''month'',&RUN_DATE,0,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(11,3,1,1,'',1717,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(13,3,1,1,'',1717,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(98,3,1,1,'',1717,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(100,3,1,1,'',1717,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(131,3,1,1,'',1717,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(133,3,1,1,'',1717,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(135,3,1,1,'',1717,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(132,2,1,1,'',1964,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(134,2,1,1,'',1964,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(70,3,1,1,'',2204,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(63,3,1,1,'',2204,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(54,3,1,1,'',2204,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(45,3,1,1,'',2204,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(43,3,2,2,'AND',2204,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(43,4,2,2,'AND',2204,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(52,2,2,2,'AND',2204,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(52,5,2,2,'AND',2204,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(61,2,2,2,'AND',2204,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(61,4,2,2,'AND',2204,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(65,2,2,2,'AND',2204,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(65,6,2,2,'AND',2204,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,3,2,2,'AND',2204,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,4,2,2,'AND',2204,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(106,3,2,2,'AND',2204,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(106,4,2,2,'AND',2204,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(107,2,2,2,'AND',2204,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(107,5,2,2,'AND',2204,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(108,2,2,2,'AND',2204,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(108,4,2,2,'AND',2204,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(109,2,2,2,'AND',2204,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(109,6,2,2,'AND',2204,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(110,3,2,2,'AND',2204,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(110,4,2,2,'AND',2204,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(112,3,2,2,'AND',2204,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(112,4,2,2,'AND',2204,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(115,2,2,2,'AND',2204,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(115,4,2,2,'AND',2204,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(117,2,2,2,'AND',2204,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(117,4,2,2,'AND',2204,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(118,2,2,2,'AND',2204,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(118,5,2,2,'AND',2204,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(121,2,2,2,'AND',2204,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(121,5,2,2,'AND',2204,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(123,2,2,2,'AND',2204,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(123,5,2,2,'AND',2204,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(143,2,2,2,'AND',2204,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(143,6,2,2,'AND',2204,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(18,2,1,1,'',2221,6,'Y','%dabt_intnx(''month'', &RUN_DATE, -&MOB ,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(22,2,1,1,'',2221,6,'Y','%dabt_intnx(''month'', &RUN_DATE, -&MOB ,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(23,2,1,1,'',2221,6,'Y','%dabt_intnx(''month'', &RUN_DATE, -&MOB ,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(79,2,1,1,'',2221,6,'Y','%dabt_intnx(''month'', &RUN_DATE, -&MOB ,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(80,2,1,1,'',2221,6,'Y','%dabt_intnx(''month'', &RUN_DATE, -&MOB ,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(82,2,1,1,'',2221,6,'Y','%dabt_intnx(''month'', &RUN_DATE, -&MOB ,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(84,2,1,1,'',2221,6,'Y','%dabt_intnx(''month'', &RUN_DATE, -&MOB ,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(86,2,1,1,'',2221,6,'Y','%dabt_intnx(''month'', &RUN_DATE, -&MOB ,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(32,2,1,1,'',2222,6,'Y','%dabt_intnx(''month'', &RUN_DATE , -&MOB_CUSTOMER ,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(37,2,1,1,'',2223,6,'Y','%dabt_intnx(''month'', &RUN_DATE , -&MOB_CUSTOMER ,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(43,2,1,1,'',2224,5,'Y','%dabt_intnx(''month'', &RUN_DATE, -&DEFAULT_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(43,2,2,2,'AND',2224,6,'Y','%dabt_intnx(''month'', &RUN_DATE, 0 ,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(52,4,1,1,'',2224,5,'Y','%dabt_intnx(''month'', &RUN_DATE, -&DEFAULT_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(52,4,2,2,'AND',2224,6,'Y','%dabt_intnx(''month'', &RUN_DATE, 0 ,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(61,3,1,1,'',2224,5,'Y','%dabt_intnx(''month'', &RUN_DATE, -&DEFAULT_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(61,3,2,2,'AND',2224,6,'Y','%dabt_intnx(''month'', &RUN_DATE, 0 ,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(65,4,1,1,'',2224,5,'Y','%dabt_intnx(''month'', &RUN_DATE, -&DEFAULT_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(65,4,2,2,'AND',2224,6,'Y','%dabt_intnx(''month'', &RUN_DATE, 0 ,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,2,1,1,'',2224,5,'Y','%dabt_intnx(''month'', &RUN_DATE, -&DEFAULT_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,2,2,2,'AND',2224,6,'Y','%dabt_intnx(''month'', &RUN_DATE, 0 ,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(106,2,1,1,'',2224,5,'Y','%dabt_intnx(''month'', &RUN_DATE, -&DEFAULT_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(106,2,2,2,'AND',2224,6,'Y','%dabt_intnx(''month'', &RUN_DATE, 0 ,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(107,4,1,1,'',2224,5,'Y','%dabt_intnx(''month'', &RUN_DATE, -&DEFAULT_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(107,4,2,2,'AND',2224,6,'Y','%dabt_intnx(''month'', &RUN_DATE, 0 ,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(108,3,1,1,'',2224,5,'Y','%dabt_intnx(''month'', &RUN_DATE, -&DEFAULT_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(108,3,2,2,'AND',2224,6,'Y','%dabt_intnx(''month'', &RUN_DATE, 0 ,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(109,4,1,1,'',2224,5,'Y','%dabt_intnx(''month'', &RUN_DATE, -&DEFAULT_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(109,4,2,2,'AND',2224,6,'Y','%dabt_intnx(''month'', &RUN_DATE, 0 ,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(110,2,1,1,'',2224,5,'Y','%dabt_intnx(''month'', &RUN_DATE, -&DEFAULT_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(110,2,2,2,'AND',2224,6,'Y','%dabt_intnx(''month'', &RUN_DATE, 0 ,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(112,2,1,1,'',2224,5,'Y','%dabt_intnx(''month'', &RUN_DATE, -&DEFAULT_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(112,2,2,2,'AND',2224,6,'Y','%dabt_intnx(''month'', &RUN_DATE, 0 ,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(115,3,1,1,'',2224,5,'Y','%dabt_intnx(''month'', &RUN_DATE, -&DEFAULT_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(115,3,2,2,'AND',2224,6,'Y','%dabt_intnx(''month'', &RUN_DATE, 0 ,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(117,3,1,1,'',2224,5,'Y','%dabt_intnx(''month'', &RUN_DATE, -&DEFAULT_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(117,3,2,2,'AND',2224,6,'Y','%dabt_intnx(''month'', &RUN_DATE, 0 ,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(118,4,1,1,'',2224,5,'Y','%dabt_intnx(''month'', &RUN_DATE, -&DEFAULT_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(118,4,2,2,'AND',2224,6,'Y','%dabt_intnx(''month'',&RUN_DATE, 0 ,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(121,4,1,1,'',2224,5,'Y','%dabt_intnx(''month'', &RUN_DATE, -&DEFAULT_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(121,4,2,2,'AND',2224,6,'Y','%dabt_intnx(''month'',&RUN_DATE, 0 ,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(123,4,1,1,'',2224,5,'Y','%dabt_intnx(''month'',&RUN_DATE, -&DEFAULT_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(123,4,2,2,'AND',2224,6,'Y','%dabt_intnx(''month'',&RUN_DATE, 0 ,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(143,4,1,1,'',2224,5,'Y','%dabt_intnx(''month'',&RUN_DATE, -&DEFAULT_CAPTURE_PERIOD+1,''begin'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(143,4,2,2,'AND',2224,6,'Y','%dabt_intnx(''month'',&RUN_DATE, 0 ,''end'')',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(18,3,1,1,'',2256,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(20,3,1,1,'',2256,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(79,3,1,1,'',2256,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(80,3,1,1,'',2256,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(82,3,1,1,'',2256,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(84,3,1,1,'',2256,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(86,3,1,1,'',2256,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(25,4,1,1,'',2257,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(27,3,1,1,'',2257,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(88,4,1,1,'',2257,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(90,4,1,1,'',2257,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(137,4,1,1,'',2257,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(139,4,1,1,'',2257,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(141,4,1,1,'',2257,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(103,2,1,1,'',2258,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(111,2,1,1,'',2258,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(114,2,1,1,'',2258,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(116,2,1,1,'',2258,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(120,2,1,1,'',2258,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(122,2,1,1,'',2258,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(126,2,1,1,'',2259,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(128,2,1,1,'',2259,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(130,2,1,1,'',2259,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(37,4,1,1,'',540,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(76,4,1,1,'',1589,7,'N','',"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

;

quit;



proc sql;

insert into &csb_apdm_lib_ref..FILTER_NODE_EXPRSSN_X_VALUE (

SUBSET_QUERY_SK ,SUBSET_FILTER_NODE_SK ,SUBSET_FILTER_NODE_EXPRSSN_SK ,DIM_ATTRIBUTE_VALUE_SK 

)

VALUES(27,2,1,839)

VALUES(25,3,2,839)

VALUES(39,2,1,1269)

VALUES(43,4,1,779)

VALUES(43,5,1,776)

VALUES(45,2,1,776)

VALUES(52,2,1,779)

VALUES(52,5,1,776)

VALUES(54,2,1,776)

VALUES(61,2,1,779)

VALUES(61,4,1,776)

VALUES(63,2,1,776)

VALUES(65,2,1,779)

VALUES(65,6,1,776)

VALUES(70,2,1,776)

VALUES(2,4,1,583)

VALUES(11,3,1,1306)

VALUES(13,3,1,1306)

VALUES(4,3,1,583) 

VALUES(37,3,1,1307)

VALUES(39,3,1,1307)

VALUES(70,3,1,1230)

VALUES(63,3,1,1229)

VALUES(54,3,1,1230)

VALUES(25,4,1,1314) 

VALUES(27,3,1,1314) 

VALUES(79,2,2,503)

VALUES(80,2,2,503)

VALUES(82,2,2,503)

VALUES(84,2,2,503)

VALUES(86,2,2,503)

VALUES(88,3,2,839)

VALUES(88,4,1,1314) 

VALUES(90,3,2,839)

VALUES(90,4,1,1314) 

VALUES(92,4,1,583)

VALUES(93,2,1,773)

VALUES(94,4,1,583)

VALUES(95,2,1,770)

VALUES(96,4,1,583)

VALUES(97,2,1,771)

VALUES(98,3,1,1306)

VALUES(100,3,1,1306)

VALUES(43,3,2,1229)

VALUES(43,4,2,1229)

VALUES(52,2,2,1230)

VALUES(52,5,2,1230)

VALUES(45,3,1,1229)

VALUES(61,2,2,1229)

VALUES(61,4,2,1229)

VALUES(65,2,2,1230)

VALUES(65,6,2,1230)

VALUES(102,4,1,779)

VALUES(102,5,1,776)

VALUES(102,3,2,1229)

VALUES(102,4,2,1229)

VALUES(106,4,1,779)

VALUES(106,5,1,776)

VALUES(106,3,2,1229)

VALUES(106,4,2,1229)

VALUES(107,2,1,779)

VALUES(107,5,1,776)

VALUES(107,2,2,1230)

VALUES(107,5,2,1230)

VALUES(108,2,1,779)

VALUES(108,4,1,776)

VALUES(108,2,2,1229)

VALUES(108,4,2,1229)

VALUES(109,2,1,779)

VALUES(109,6,1,776)

VALUES(109,2,2,1230)

VALUES(109,6,2,1230)

VALUES(103,2,1,1353)

VALUES(110,4,1,779)

VALUES(110,5,1,776)

VALUES(110,3,2,1229)

VALUES(110,4,2,1229)

VALUES(111,2,1,1354)

VALUES(112,4,1,779)

VALUES(112,5,1,776)

VALUES(112,3,2,1229)

VALUES(112,4,2,1229)

VALUES(114,2,1,1355)

VALUES(115,2,1,779)

VALUES(115,4,1,776)

VALUES(115,2,2,1229)

VALUES(115,4,2,1229)

VALUES(116,2,1,1355)

VALUES(117,2,1,779)

VALUES(117,4,1,776)

VALUES(117,2,2,1229)

VALUES(117,4,2,1229)

VALUES(118,2,1,779)

VALUES(118,5,1,776)

VALUES(118,2,2,1230)

VALUES(118,5,2,1230)

VALUES(120,2,1,1353)

VALUES(121,2,1,779)

VALUES(121,5,1,776)

VALUES(121,2,2,1230)

VALUES(121,5,2,1230)

VALUES(122,2,1,1354)

VALUES(123,2,1,779)

VALUES(123,5,1,776)

VALUES(123,2,2,1230)

VALUES(123,5,2,1230)

VALUES(126,2,1,1357)

VALUES(128,2,1,1359)

VALUES(130,2,1,1358)

VALUES(131,3,1,1306)

VALUES(132,2,1,914)

VALUES(133,3,1,1306)

VALUES(134,2,1,915)

VALUES(135,3,1,1306)

VALUES(137,3,2,839)

VALUES(137,4,1,1314) 

VALUES(138,2,1,788)

VALUES(139,3,2,839)

VALUES(139,4,1,1314) 

VALUES(140,2,1,789)

VALUES(141,3,2,839)

VALUES(141,4,1,1314) 

VALUES(143,2,1,779)

VALUES(143,6,1,776)

VALUES(143,2,2,1230)

VALUES(143,6,2,1230)

VALUES(37,4,1,1269)

VALUES(76,4,1,1360)

VALUES(18,2,2,503)

VALUES(20,2,1,503)

VALUES(22,2,2,503)

VALUES(23,2,2,503)

VALUES(32,2,2,1268)

VALUES(34,2,1,1268)

VALUES(32,3,1,1270)

VALUES(34,3,1,1270)

VALUES(18,3,1,1315)

VALUES(20,3,1,1315)

VALUES(79,3,1,1315)

VALUES(80,3,1,1315)

VALUES(82,3,1,1315)

VALUES(84,3,1,1315)

VALUES(86,3,1,1315)

;

quit;



proc sql;

  insert into &csb_apdm_lib_ref..POST_ACTION_MACRO_CONFIG_DTL

  (action_sk,purpose_sk,POST_ACTION_MACRO_NM)
  
  values  (13,103,'csbmva_post_actual_calc_wrapper')
  values  (14,103,'csbmva_post_bck_calc_wrapper')
  values  (15,103,'csbmva_post_plg_calc_wrapper')

  values 
  (5,101,'csbmva_capture_model_wrapper')

  values

  (5,102,'csbmva_capture_model_wrapper')

  values

  (5,103,'csbmva_capture_model_wrapper')

  values

  (6,101,'csbmva_edit_model_wrapper')

  values

  (6,102,'csbmva_edit_model_wrapper')

  values

  (6,103,'csbmva_edit_model_wrapper')

  values

  (16,101,'csbmva_edit_model_wrapper')

  values

  (16,102,'csbmva_edit_model_wrapper')

  values

  (16,103,'csbmva_edit_model_wrapper')
  
  values

  (17,101,'csbmva_edit_model_wrapper')

  values

  (17,102,'csbmva_edit_model_wrapper')

  values
  
  (17,103,'csbmva_edit_model_wrapper')

  values

  (8,101,'csbmva_setforscoring_model')

  values

  (8,102,'csbmva_setforscoring_model')

  values

  (8,103,'csbmva_set_scoring_recv_ccf')

    values

  (3,102,'csbmva_setrecovery_lgd')

    values

  (3,101,'csbmva_upd_impl_subset')

    values

  (3,103,'csbmva_upd_impl_subset')

    values

  (11,102,'csbmva_setdefaults')

    values

  (12,102,'csbmva_setoutcome_period')

    values

  (7,101,'csbmva_delete_model_wrapper')

    values

  (7,102,'csbmva_delete_model_wrapper')

    values

  (7,103,'csbmva_delete_model_wrapper')

  ;

quit;





proc sql;

insert into &csb_apdm_lib_ref..TABLE_X_LEVEL_KEY_COLUMN (

SOURCE_TABLE_SK ,LEVEL_KEY_COLUMN_DTL_SK ,CORRSP_SOURCE_COLUMN_SK

)

VALUES(62,9,2881)

;

quit;





proc sql;

insert into &csb_apdm_lib_ref..PRODUCT_WISE_VALID_PURPOSE_CD(

PRODUCT_CD ,APPLICABLE_PURPOSE_CD 

)

VALUES("csbmid","PD,LGD,CCF")

;

quit;




proc sql;

insert into &csb_apdm_lib_ref..BIN_ANALYSIS_SCHEME_DEFN(

BIN_ANALYSIS_SCHEME_SK,BIN_ANALYSIS_SCHEME_DESC,BIN_ANALYSIS_SCHEME_SHORT_NM, 
BIN_ANALYSIS_SCHEME_TYPE_SK, BIN_ANALYSIS_SCHEME_CD, 
CREATED_DTTM, CREATED_BY_USER,LAST_PROCESSED_DTTM, LAST_PROCESSED_BY_USER

)

VALUES(1, "%sysfunc(sasmsg(SASHELP.csbmva_bin_analysis_scheme_defn,BIN_ANALYSIS_SCHEME_DEFN.SCHEME_DS1.1, noquote))","%sysfunc(sasmsg(SASHELP.csbmva_bin_analysis_scheme_defn,BIN_ANALYSIS_SCHEME_DEFN.SCHEME_SM1.1, noquote))",
1,"PD_IMPL_BIN",
"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"
)

VALUES(2, "%sysfunc(sasmsg(SASHELP.csbmva_bin_analysis_scheme_defn,BIN_ANALYSIS_SCHEME_DEFN.SCHEME_DS2.1, noquote))","%sysfunc(sasmsg(SASHELP.csbmva_bin_analysis_scheme_defn,BIN_ANALYSIS_SCHEME_DEFN.SCHEME_SM2.1, noquote))",
1,"PD_IMPL_BIN",
"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"
)

VALUES(3, "%sysfunc(sasmsg(SASHELP.csbmva_bin_analysis_scheme_defn,BIN_ANALYSIS_SCHEME_DEFN.SCHEME_DS3.1, noquote))","%sysfunc(sasmsg(SASHELP.csbmva_bin_analysis_scheme_defn,BIN_ANALYSIS_SCHEME_DEFN.SCHEME_SM3.1, noquote))",
1,"LGD_IMPL_BIN",
"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"
)

VALUES(4, "%sysfunc(sasmsg(SASHELP.csbmva_bin_analysis_scheme_defn,BIN_ANALYSIS_SCHEME_DEFN.SCHEME_DS4.1, noquote))","%sysfunc(sasmsg(SASHELP.csbmva_bin_analysis_scheme_defn,BIN_ANALYSIS_SCHEME_DEFN.SCHEME_SM4.1, noquote))",
1,"CCF_IMPL_BIN",
"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"
)
;

quit;

proc sql;

insert into &csb_apdm_lib_ref..BIN_SCHEME_BNNG_ATTRB_DEFN(

BIN_SCHEME_BNNG_ATTRB_SK, BIN_ANALYSIS_SCHEME_SK, BINNING_ATTRIB_SEQ_NO, BINNING_ATTRIB_CD, BNNG_ATTRB_MDL_ASS_INF_TYPE_SK, BNNG_ATTRB_VARIABLE_SK, BNNG_ATTRB_SCR_OUTPUT_TYPE_SK,
CREATED_DTTM, CREATED_BY_USER,LAST_PROCESSED_DTTM, LAST_PROCESSED_BY_USER

)

VALUES(1, 1, 1, "CSB_SCORE_POINT",1, ., 3, 
"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"
)

VALUES(2, 2, 1, "CSB_SCORE_POINT",1,. , 3, 
"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"
)

VALUES(3, 3, 1, "CSB_P_LGD",1, ., 2, 
"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"
)

VALUES(4, 4, 1, "CSB_P_CCF",1,. , 2, 
"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"
)
;

quit;

proc sql;

insert into &csb_apdm_lib_ref..BIN_CHARACTERISTIC(

BIN_CHRSTC_SK, 	BIN_CHRSTC_CD , 
BIN_CHRSTC_DESC, BIN_CHRSTC_SHORT_NM,   
CHRSTC_CALC_TEMPLATE_SK, MANUAL_EDIT_APPLICABLE_FLG, DISPLAY_IN_VIEW_MODE_FLG,
VALID_MIN_OF_TOTAL_ACROSS_BIN,VALID_MAX_OF_TOTAL_ACROSS_BIN,VALID_MIN_VALUE, VALID_MAX_VALUE, TOTAL_VALUE_APPLICABLE_FLAG,
CREATED_DTTM, CREATED_BY_USER, LAST_PROCESSED_DTTM, LAST_PROCESSED_BY_USER 

)

VALUES(1,"CSB_TOT_PROP", 
"%sysfunc(sasmsg(SASHELP.csbmva_bin_chrstc,BIN_CHARACTERISTIC.DS1.1, noquote))","%sysfunc(sasmsg(SASHELP.csbmva_bin_chrstc,BIN_CHARACTERISTIC.SM1.1, noquote))",
1,"Y","Y",
99.99,100.01,0,100,"Y",
"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"
)

VALUES(2,"CSB_PROP_GOOD", 
"%sysfunc(sasmsg(SASHELP.csbmva_bin_chrstc,BIN_CHARACTERISTIC.DS2.1, noquote))","%sysfunc(sasmsg(SASHELP.csbmva_bin_chrstc,BIN_CHARACTERISTIC.SM2.1, noquote))",
1,"N","Y",
99.99,100.01,0,100,"Y",
"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"
)

VALUES(3,"CSB_PROP_BAD",
"%sysfunc(sasmsg(SASHELP.csbmva_bin_chrstc,BIN_CHARACTERISTIC.DS3.1, noquote))","%sysfunc(sasmsg(SASHELP.csbmva_bin_chrstc,BIN_CHARACTERISTIC.SM3.1, noquote))",
1,"N","Y",
99.99,100.01,0,100,"Y",
"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"
)

VALUES(4,"CSB_EXP_PD", 
"%sysfunc(sasmsg(SASHELP.csbmva_bin_chrstc,BIN_CHARACTERISTIC.DS4.1, noquote))","%sysfunc(sasmsg(SASHELP.csbmva_bin_chrstc,BIN_CHARACTERISTIC.SM4.1, noquote))",
5,"Y","Y",
.,.,0,1,"N",
"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"
)

VALUES(5,"CSB_EXP_PD",
"%sysfunc(sasmsg(SASHELP.csbmva_bin_chrstc,BIN_CHARACTERISTIC.DS5.1, noquote))","%sysfunc(sasmsg(SASHELP.csbmva_bin_chrstc,BIN_CHARACTERISTIC.SM5.1, noquote))",
3,"Y","Y",
.,.,0,1,"N",
"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"
)

VALUES(6,"CSB_EXP_LGD", 
"%sysfunc(sasmsg(SASHELP.csbmva_bin_chrstc,BIN_CHARACTERISTIC.DS6.1, noquote))","%sysfunc(sasmsg(SASHELP.csbmva_bin_chrstc,BIN_CHARACTERISTIC.SM6.1, noquote))",
3,"Y","Y",
.,.,.,.,"N",
"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"
)

VALUES(7,"CSB_EXP_CCF",
"%sysfunc(sasmsg(SASHELP.csbmva_bin_chrstc,BIN_CHARACTERISTIC.DS7.1, noquote))","%sysfunc(sasmsg(SASHELP.csbmva_bin_chrstc,BIN_CHARACTERISTIC.SM7.1, noquote))",
3,"Y","Y",
.,.,.,.,"N",
"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"
)

VALUES(8,"CSB_TOT_CNT", 
"%sysfunc(sasmsg(SASHELP.csbmva_bin_chrstc,BIN_CHARACTERISTIC.DS8.1, noquote))","%sysfunc(sasmsg(SASHELP.csbmva_bin_chrstc,BIN_CHARACTERISTIC.SM8.1, noquote))",
3,"N","N",
.,.,.,.,"N",
"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"
)

VALUES(9,"CSB_BAD_CNT", 
"%sysfunc(sasmsg(SASHELP.csbmva_bin_chrstc,BIN_CHARACTERISTIC.DS9.1, noquote))","%sysfunc(sasmsg(SASHELP.csbmva_bin_chrstc,BIN_CHARACTERISTIC.SM9.1, noquote))",
3,"N","N",
.,.,.,.,"N",
"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"
)

VALUES(10,"CSB_TOT_PROP", 
"%sysfunc(sasmsg(SASHELP.csbmva_bin_chrstc,BIN_CHARACTERISTIC.DS10.1, noquote))","%sysfunc(sasmsg(SASHELP.csbmva_bin_chrstc,BIN_CHARACTERISTIC.SM10.1, noquote))",
1,"Y","Y",
99.99,100.01,0,100,"Y",
"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"
)

VALUES(11,"CSB_TOT_CNT", 
"%sysfunc(sasmsg(SASHELP.csbmva_bin_chrstc,BIN_CHARACTERISTIC.DS11.1, noquote))","%sysfunc(sasmsg(SASHELP.csbmva_bin_chrstc,BIN_CHARACTERISTIC.SM11.1, noquote))",
3,"N","N",
.,.,.,.,"N",
"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"
)

;

quit;


proc sql;

insert into &csb_apdm_lib_ref..BIN_CHRSTC_AGGREGATION_DTL(

BIN_CHRSTC_SK ,	AGGREGATION_TYPE_SK ,CHRSTC_MSR_ATTRB_INF_TYPE_SK,CHRSTC_MSR_ATTRB_VARIABLE_SK, CHRSTC_MSR_ATTRB_OTPT_TYPE_SK ,
CREATED_DTTM, CREATED_BY_USER, LAST_PROCESSED_DTTM, LAST_PROCESSED_BY_USER 

)

VALUES(5,6, 1,., 1
"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"
)

VALUES(6,6, 1,., 2
"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"
)

VALUES(7,6, 1,., 2
"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"
)

VALUES(8,5, .,., .
"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"
)

VALUES(9,5, .,., .
"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"
)

VALUES(11,5, .,., .
"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"
)

;

quit;

proc sql;

insert into &csb_apdm_lib_ref..DEFAULT_SCORECARD_CHRSTC_CONFG(

PURPOSE_SK, MODEL_SOURCE_TYPE_SK, BIN_CHRSTC_SK, SEQ_NO_PER_PURPOSE_MODEL_TYPE

)

VALUES(101,1, 1, 1)
VALUES(101,1, 2, 2)
VALUES(101,1, 3, 3)
VALUES(101,1, 5, 4)
VALUES(101,1, 8, 5)
VALUES(101,1, 9, 6)
VALUES(101,2, 1, 1)
VALUES(101,2, 2, 2)
VALUES(101,2, 3, 3)
VALUES(101,2, 4, 4)
VALUES(101,2, 8, 5)
VALUES(101,2, 9, 6)
;

quit;


proc sql;

insert into &csb_apdm_lib_ref..BIN_SCHEME_BIN_CHRSTC_DEFN(
BIN_SCHEME_BIN_CHRSTC_SK, BIN_ANALYSIS_SCHEME_SK, BIN_CHRSTC_SK, SEQ_NO_PER_SCHEME,
CREATED_DTTM, CREATED_BY_USER, LAST_PROCESSED_DTTM, LAST_PROCESSED_BY_USER 
)

VALUES(1,1, 1, 1, "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid")
VALUES(2,1, 2, 2, "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid")
VALUES(3,1, 3, 3, "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid")
VALUES(4,1, 5, 4, "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid")
VALUES(5,2, 1, 1, "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid")
VALUES(6,2, 2, 2, "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid")
VALUES(7,2, 3, 3, "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid")
VALUES(8,2, 4, 4, "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid")
VALUES(9,3, 10, 1, "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid")
VALUES(10,3, 6, 2, "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid")
VALUES(11,4, 10, 1, "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid")
VALUES(12,4, 7, 2, "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid")
VALUES(13,1, 8, 5, "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid")
VALUES(14,1, 9, 6, "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid")
VALUES(15,2, 8, 5, "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid")
VALUES(16,2, 9, 6, "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid")
VALUES(17,3, 11, 3, "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid")
VALUES(18,4, 11, 3, "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid")

;

quit;


proc sql;

insert into &csb_apdm_lib_ref..BIN_CHRSTC_FILTER_DTL(
	BIN_CHRSTC_SK ,	SQNC_NUM ,FILTER_SPEC_TYPE_CD ,	MULTI_CONDTN_BOOLEAN_OPRTR_VAL ,
	FILTER_OPERAND_INF_TYPE_SK ,FILTER_OPERAND_VARIABLE_SK , FILTER_OPERAND_OTPT_TYPE_SK ,	FILTER_VALUE_TXT    ,
CREATED_DTTM, CREATED_BY_USER, LAST_PROCESSED_DTTM, LAST_PROCESSED_BY_USER 
)
/*
VALUES(1,1, "NA","",
2,., .,"0;1",
"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"
)
*/

VALUES(2,1,"NA","",
2,., .,'0, &CSB_LIST_INDETERMINATE_VALUES.',
"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"
)

VALUES(3,1,"NA","",
2,., .,"1",
"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"
)

VALUES(4,1,"NUMERATOR","",
2,., .,"1",
"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"
)
/*
VALUES(4,1,"DENOMINATOR","",
2,., .,"0;1",
"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"
)
*/
/*
VALUES(5,1,"NA","",
2,., .,"0;1",
"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"
)
*/
/*
VALUES(8,1,"NA","",
2,., .,"0;1",
"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"
)
*/

VALUES(9,1,"NA","",
2,., .,"1",
"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"
)

;


quit;


proc sql; 


 insert into &csb_apdm_lib_ref..PARAMETER_MASTER 


( 


PARAMETER_NM, PARAMETER_DESC,  


PARAM_ADDED_BY_PRODUCT_CD ,VALUE_EDITABLE_FLG, VALUE_TO_BE_SET_BY_SOLUTN_FLG,  


CREATED_DTTM, CREATED_BY_USER , LAST_PROCESSED_DTTM, LAST_PROCESSED_BY_USER 


) 


values  
( 

'CSB_UPDT_LGD_POST_BUILD_FLG', 'Initially LGD related variables were calculated based on base tables via DI Studio ETLs. As part of hotfix for LGD processing, in last step of abt building, LGD related variables are calculated based on FM tables via a sas code. This parameter is used to decide whether or not to activate this change after applying hot fix. If values is set to N, it will not invoke newly added sas code.', 
'csbmid','Y','Y',  
"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid" 
) 

values  
( 
'CSB_DEF_CPTR_PERIOD_POST_LGD_SCR', 'This parameter denotes default capture period (in months/day depending on grain of FM) post reference abt scoring date for LGD process. We score only non-default accounts. Then after scoring, we observe whether accounts default in this default capture period. LGD is calculated for these defaulted accounts.', 
'csbmid','Y','Y',  
"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid" 
) 
 


values  


( 


'DABT_AUTO_GEN_REPORT_BCKTEST_ABT', 'This parameter is used to decide whether a version of model specification report should be automatically generated after successful execution of every backtesting run', 


'csbmid','Y','Y',  


"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid" 


) 


 


values  


( 


'DABT_AUTO_GEN_REPORT_POOLING_ABT', 'This parameter is used to decide whether a version of project report should be automatically generated after successful execution of every build modeling abt run', 


'csbmid','Y','Y',  


"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid" 


) 


values  
( 
'CSB_LIST_INDETERMINATE_VALUES', 'This parameter is used to specify values of PD outcome variables which mean indeterminate i.e. which are niether good nor bad. These should be other 0 and 1 which mean Good and Bad respectively. If there are multiple values they should be separated by comma.', 
'csbmid','Y','Y',  
"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid" 

)
 


; 


Quit; 


proc sql;

 insert into &csb_apdm_lib_ref..PARAMETER_VALUE_DTL

(

	PARAMETER_NM, VALUE_APPLICABLE_TO_PRODUCT_CD, PARAMETER_VALUE,CREATED_DTTM, CREATED_BY_USER ,	LAST_PROCESSED_DTTM, LAST_PROCESSED_BY_USER

)

values 
(
'CSB_UPDT_LGD_POST_BUILD_FLG', 'csbmid','Y', 
"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"
)

values 
(
'CSB_DEF_CPTR_PERIOD_POST_LGD_SCR', 'csbmid','&DEFAULT_CAPTURE_PERIOD', 
"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"
)

values 

(
'DABT_REF_OBJECT_TYPE_FOR_POOLING', 'csbmid','MDL_SPEC', 
"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"
)

values 

(

'DABT_REF_OBJECT_TYPE_FOR_BCKTEST', 'csbmid','MDL_SPEC', 

"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

)

values 

(

'IM_SUBSET_TABLE_LIBREF', 'csbmid','dabt_sub', 

"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

)

	

values 

(

'WEEK_END_DAY_NM', 'csbmid','SATURDAY', 

"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

)



values 

(

'MCR_DABT_CREATE_EVENT_DATA', 'csbmid','bankfdn_create_event_data', 

"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

)



values 

(

'MCR_DABT_UPDATE_ACT_RSLT_COLUMN', 'csbmid','bankfdn_update_act_rslt_column', 

"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

)



values 

(

'MCR_DABT_UPDATE_SCR_RSLT_COLUMN', 'csbmid','bankfdn_update_scr_rslt_column', 

"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

)



values 

(

'MCR_DABT_RULES_FILTER', 'csbmid','', 

"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

)



values 

(

'LIBREF_DABT_INPUT_MART_CONTROL', 'csbmid','control', 

"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

)



values 

( 

'TABLE_DABT_INPUT_MART_CONTROL', 'csbmid','VIEW_FM_LOAD_DATES', 

"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid" 

) 

values 
(
'CSB_LIST_INDETERMINATE_VALUES', 'csbmid','2,3,4,5,6,7,8,9', 
"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

)

values 

(

'OC_BSD_PST_IMPL_SBST_VALUE', 'csbmid','0, &CSB_LIST_INDETERMINATE_VALUES.', 

"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

)



values 

(

'APPLY_NULL_CONDTN_FOR_CPX_VAR', 'csbmid','N', 

"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

)



values 

(

'CASE_CONDN_DATE_DATA_TYPE', 'csbmid',"( kupcase(TYPE) ='NUM' and ( SUBSTR(NAME ,length(NAME)-2,3)='_DT' OR ( substr(FORMAT,1,4) = 'DATE' AND substr(FORMAT,1,8) <> 'DATETIME' ) OR substr(FORMAT,1,6) = ('NLDATE') )) ", 

"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

)



values 

(

'CASE_CONDN_DTTM_DATA_TYPE', 'csbmid',"( kupcase(TYPE) ='NUM' and ( SUBSTR(NAME ,length(NAME)-4,5)='_DTTM' OR substr(FORMAT,1,8) = 'DATETIME' OR substr(FORMAT,1,6) = ('NLDATM')))", 

"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

)



values 

(

'CASE_CONDN_NUM_DATA_TYPE', 'csbmid',"( kupcase(TYPE)='NUM')", 

"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

)



values 

(

'CASE_CONDN_CHR_DATA_TYPE', 'csbmid',"( kupcase(TYPE)='CHAR')", 

"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

)

values 

(

'CASE_CONDN_DIM_COLUMN_TYPE', 'csbmid',"( kupcase(TYPE)='CHAR' and ( SUBSTR(NAME,length(NAME)-2,3)='_CD' or SUBSTR(NAME,length(NAME)-3,4)='_FLG'))", 

"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

)

values 

(

'CASE_CONDN_KEY_COLUMN_TYPE', 'csbmid',"( kupcase(TYPE)='NUM' and SUBSTR(NAME ,length(NAME)-2,3) in ('_RK', '_SK') )", 

"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

)

values 

(

'CASE_CONDN_MSR_COLUMN_TYPE', 'csbmid',"( kupcase(TYPE)='NUM') and ( SUBSTR(NAME ,length(NAME)-3,4) in ('_AMT', '_CNT', '_PCT') or SUBSTR(NAME ,length(NAME)-2,3) in ('_RT') )", 

"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

)

values 

(

'CASE_CONDN_DATE_COLUMN_TYPE', 'csbmid','( &CASE_CONDN_DATE_DATA_TYPE. or &CASE_CONDN_DTTM_DATA_TYPE. )', 

"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

)

values 

(

'DABT_MODELING_ABT_LIBREF', 'csbmid','cs_mdl', 

"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

)

values 

(

'DABT_SCORING_ABT_LIBREF', 'csbmid','cs_scrng', 

"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

)

values 

(

'DABT_ACTUAL_CALC_ABT_LIBREF', 'csbmid','cs_act', 

"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

)

values 

(

'DABT_BACKTESTING_ABT_LIBREF', 'csbmid','cs_bck', 

"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

)

values 

(

'DABT_POOLING_ABT_LIBREF', 'csbmid','cs_pool', 

"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

)

values 

(

'DABT_MODELING_SCR_LIBREF', 'csbmid','cs_mdlsc', 

"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

)

values 

(

'DABT_SCORING_SCR_LIBREF', 'csbmid','cs_scrsc', 

"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

)

values 

(

'DABT_ACTUAL_CALC_SCR_LIBREF', 'csbmid','cs_actsc', 

"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

)

values 

(

'DABT_BACKTESTING_SCR_LIBREF', 'csbmid','cs_bksc', 

"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

)

values 

(

'DABT_POOLING_SCR_LIBREF', 'csbmid','cs_plsc', 

"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

)

values 

(

"DABT_PERFORM_SCRORING_FLG", "csbmid","Y",

"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

)



values 

(

"DABT_POPULATE_SCRORING_ARM_FLG", "csbmid","Y",

"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

)



values 

(

"DABT_POPULATE_ACTUAL_ARM_FLG", "csbmid","Y",

"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

)



values 

(

"DABT_AGG_WHILE_EXTR_FOR_BEH_FLG", "csbmid","Y",

"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

)



values 

(

"DABT_ACT_CALC_OUTCM_END_ONLY_FLG", "csbmid","N",

"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

)


values 

(

"MCR_DABT_CAL_NON_EDITABLE_CHRSTC", "csbmid","csbmva_post_manual_chrstc_edit",

"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

)

values 

(

"DABT_AUTO_GEN_REPORT_SCR_ACT_JOB", "csbmid","Y",

"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

)

values 

(

"DABT_AUTO_GEN_REPORT_MDL_ABT_JOB", "csbmid","Y",

"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

)
values 

(

"DABT_AUTO_GEN_REPORT_BCKTEST_ABT", "csbmid","Y",

"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

)

values 

(

"DABT_AUTO_GEN_REPORT_POOLING_ABT", "csbmid","Y",

"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

)



;



quit;


proc sql;

insert into &csb_apdm_lib_ref..PURPOSE_X_MODEL_SOURCE_TYPE (

PURPOSE_SK, MODEL_SOURCE_TYPE_SK, DEFAULT_BIN_ANALYSIS_SCHEME_SK ,CREATED_DTTM ,CREATED_BY_USER ,LAST_PROCESSED_DTTM ,LAST_PROCESSED_BY_USER

)

VALUES(101,1,1,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(101,2,2,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(102,1,3,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")

VALUES(103,1,4,"%sysfunc(datetime(),datetime.)"dt,"&sysuserid","%sysfunc(datetime(),datetime.)"dt,"&sysuserid")
;

quit;



%macro dabt_indb_flag;

proc sql;

insert into &csb_apdm_lib_ref..PARAMETER_VALUE_DTL

(

	PARAMETER_NM, VALUE_APPLICABLE_TO_PRODUCT_CD, PARAMETER_VALUE,CREATED_DTTM, CREATED_BY_USER ,	LAST_PROCESSED_DTTM, LAST_PROCESSED_BY_USER

)

	%if &fm_db_eng.= SAS %then %do;

		values 

		(

		'DABT_INDB_PROCESSING_FLG', 'csbmid','N', 

		"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

		)

		

		values 

		( 

		'DABT_MAX_ALLOWED_VAR_CLMN_LNGHTH', 'csbmid','28', 

		"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid" 

		)



	%end;

	%else %do;

		values 

		(

		'DABT_INDB_PROCESSING_FLG', 'csbmid','Y', 

		"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

		)

		

		values 

		( 

		'DABT_MAX_ALLOWED_VAR_CLMN_LNGHTH', 'csbmid','26', 

		"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid" 

		)

	%end;

	

	%if %kupcase(%sysfunc(kcompress(&arm_database_engine.))) = SAS %then %do;

		values 

		(

		"DABT_APPLY_TRYLOCK_SCR_ARM_FLG", "csbmid","Y",

		"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

		)

		

		values 

		(

		"DABT_APPLY_TRYLOCK_ACT_ARM_FLG", "csbmid","Y",

		"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

		)

		

	%end;

	%else %do;

		values 

		(

		"DABT_APPLY_TRYLOCK_SCR_ARM_FLG", "csbmid","N",

		"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

		)

		

		values 

		(

		"DABT_APPLY_TRYLOCK_ACT_ARM_FLG", "csbmid","N",

		"%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid", "%sysfunc(datetime(),DATETIME.)"dt, "&sysuserid"

		)

	%end;



	;

quit;

%mend dabt_indb_flag;



%dabt_indb_flag;

